'-----------------------------------------------------------------------------------------
'-----------------------------------------------------------------------------------------
' PowerBASIC v7.0x OpenGL Demo: "Flying 3D-Text" (aka; "Crazy-Clock")
' by Scott Martindale smartndl@hotmail.com
' March 28, 2003
'
' Based on Nehe's OpenGL tutorial #14
'
'-----------------------------------------------------------------------------------------
' METASTATEMENTS:     |
'---------------------'
    #Compile Exe
    #Dim All
    %USEMACROS = 1

    #Include "WIN32API.INC"
    #Include "gl.inc"
    #Include "glu.inc"


'-----------------------------------------------------------------------------------------
' GLOBAL VARIABLES:   |
'---------------------'
    Global g_HDC       As Dword
    Global gmf ()      As GLYPHMETRICSFLOAT


'-----------------------------------------------------------------------------------------
' MACROS:             |
'---------------------'
    Macro BuildFont
        MacroTemp glFont, glFontHandle
        Dim glFont As LOGFONT, glFontHandle As Long
        glFont.lfHeight         = -12                            'Height Of Font
        glFont.lfWeight         = %FW_BOLD                       'Font Weight
        glFont.lfCharSet        = %ANSI_CHARSET                  'Character Set Identifier
        glFont.lfOutPrecision   = %OUT_TT_PRECIS                 'Output Precision
        glFont.lfClipPrecision  = %CLIP_DEFAULT_PRECIS           'Clipping Precision
        glFont.lfQuality        = %ANTIALIASED_QUALITY           'Output Quality
        glFont.lfPitchAndFamily = %FF_DONTCARE Or %DEFAULT_PITCH 'Family And Pitch
        glFont.lfFaceName       = "Arial" '"Comic Sans MS"       'Font Name
        glFontHandle = CreateFontIndirect(glFont)
        glFontHandle = SelectObject(hDC, glFontHandle)
        wglUseFontOutlines hDC, 0, 255, 1000, 0.0, 0.2, %WGL_FONT_POLYGONS, VarPtr(gmf(0))
        DeleteObject SelectObject(hDC, glFontHandle)
    End Macro

    Macro KillFont
        glDeleteLists 1000, 255
    End Macro

    Macro glPrint(gltext)
        MacroTemp gltmptxt, tloop, txtcenX, txtcenY
        Dim gltmptxt As String, tloop As Long, txtcenX As Single, txtcenY As Single
        gltmptxt = gltext
        If Len(gltmptxt) Then
            txtcenX = 0 : txtcenY = 0
            For tloop = 1 To Len(gltmptxt)
                txtcenX = txtcenX + gmf(Asc(Mid$(gltmptxt,tloop,1))).gmfCellIncX
                txtcenY = txtcenY + gmf(Asc(Mid$(gltmptxt,tloop,1))).gmfCellIncY
            Next tloop
            txtcenY = Abs((txtcenY/Len(gltmptxt)) * 0.5)
            glTranslatef -txtcenX/2, txtcenY, 0.0
            glPushAttrib GL_LIST_BIT
            glListBase 1000
            glCallLists Len(gltmptxt), GL_UNSIGNED_BYTE, ByVal StrPtr(gltmptxt)
            glPopAttrib
        End If
    End Macro

'-----------------------------------------------------------------------------------------
'Forward Declarations:|
'---------------------'
 Declare Sub SetupPixelFormat(hDC As Dword)

'-----------------------------------------------------------------------------------------
'WINMAIN Function:    |
'---------------------'
 Function WinMain (ByVal hInstance     As Dword, _
                   ByVal hPrevInstance As Dword, _
                   ByVal lpCmdLine     As Asciiz Ptr, _
                   ByVal iCmdShow      As Long) As Long

    Local msg       As tagMsg
    Local wce       As WndClassEx
    Local ClassName As Asciiz * 80
    Local hWnd      As Dword
    Local angle     As Single
    Dim gmf(255)

    ClassName         = "PowerBasic OpenGL"
    wce.cbSize        = SizeOf(wce)
    wce.style         = %CS_HREDRAW Or %CS_VREDRAW
    wce.lpfnWndProc   = CodePtr(WndProc)
    wce.cbClsExtra    = 0
    wce.cbWndExtra    = 0
    wce.hInstance     = hInstance
    wce.hIcon         = LoadIcon(hInstance, "PBGL_EXAMPLE")
    wce.hCursor       = LoadCursor(%NULL, ByVal %IDC_ARROW)
    wce.hbrBackground = %NULL
    wce.lpszMenuName  = %NULL
    wce.lpszClassName = VarPtr(ClassName)
    wce.hIconSm       = LoadIcon(hInstance, ByVal %IDI_APPLICATION)

    If IsFalse(RegisterClassEx(wce)) Then
        MsgBox "Unable to Register Window Class."
        Exit Function
    End If

  'Create a window using the registered class
        hWnd = CreateWindowEx(%NULL,_                               ' extended style
                          ClassName,_                               ' window class name
                          "PowerBASIC OpenGL Flying 3D-Text Demo",_ ' window caption
                          %WS_OVERLAPPEDWINDOW Or _                 ' window style
                          %WS_VISIBLE Or %WS_SYSMENU,_
                          100, 100,_                                ' initial x, y position
                          640, 480,_                                ' initial x, y size
                          %NULL, _                                  ' parent window handle
                          %NULL, _                                  ' window menu handle
                          hInstance, _                              ' program instance handle
                          ByVal %NULL)                              ' creation parameters

        If hWnd = 0 Then
            MsgBox "Unable to create window"
            Exit Function
        End If

  'Display the window on the screen, and set window's OpenGL attributes
        ShowWindow hWnd, iCmdShow
        UpdateWindow hWnd
        SetForegroundWindow hWnd
        SetFocus hWnd

        glShadeModel GL_SMOOTH                            'Enable Smooth Shading
        glClearColor 0.0, 0.0, 0.0, 0.5                   'Black Background
        glClearDepth 1.0                                  'Depth Buffer Setup
        glEnable GL_DEPTH_TEST                            'Enables Depth Testing
        glDepthFunc GL_LEQUAL                             'The Type Of Depth Testing To Do
        glHint GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST  'Really Nice Perspective Calculations
        glEnable GL_LIGHT0                                'Enable Default Light (Quick And Dirty)
        glEnable GL_LIGHTING                              'Enable Lighting
        glEnable GL_COLOR_MATERIAL                        'Enable Coloring Of Material

  'Main message loop:
        Do
            If PeekMessage(msg, hWnd, 0, 0, %PM_NOREMOVE) Then
                If GetMessage(msg, hWnd, 0, 0) Then
                    TranslateMessage msg
                    DispatchMessage  msg
                    Else
                        Exit Do
                End If

                Else
                   'Display 3D Text...
                        glClear GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT
                        glLoadIdentity
                        glTranslatef 0.0, 0.0, -10.0        'Move xx Units "Into" The Screen
                        glRotatef angle,1.0, 0.0, 0.0       'Rotate On The X Axis
                        glRotatef angle*1.5, 0.0, 1.0, 0.0  'Rotate On The Y Axis
                        glRotatef angle*1.4, 0.0, 0.0, 1.0  'Rotate On The Z Axis
                   'Pulsing Colors Based on the Value of Angle
                        glColor3f(Cos(angle/20.0),Sin(angle/25.0), 1.0-(0.5*Cos(angle/17.0)))
                        Sleep 10
                        glPrint("http://bbs.vbstreets.ru/")

                        angle = angle + 0.5                 'Increase The Angle Variable
                        glFlush
                        SwapBuffers g_HDC
            End If
        Loop

    Function = msg.wParam
End Function


'-----------------------------------------------------------------------------------------
'WndProc Function:    |
'---------------------'
 Function WndProc (ByVal hWnd As Dword, ByVal wMsg As Dword, _
                   ByVal wParam As Long, ByVal lParam As Long)As Long

    Static hDC      As Dword
    Static hRC      As Dword

    Select Case wMsg

    Case %WM_ACTIVATE
        If HiWrd(wParam) Then
            Function = 0
            Exit Function
        End If

    Case %WM_CREATE
        hDC   = GetDC(hWnd)
        g_hDC = hDC
        Call SetupPixelFormat(hDC)
        hRC = wglCreateContext(hDC)
        wglMakeCurrent hDC, hRC
        BuildFont
        Function = 0
        Exit Function

    Case %WM_CLOSE
        wglMakeCurrent hDC, %NULL
        wglDeleteContext hDC
        KillFont
        PostQuitMessage 0
        Function = 0
        ExitProcess(0)
        Exit Function

    Case %WM_CHAR
        Select Case wParam
            Case %VK_ESCAPE
                PostQuitMessage 0
                Function = 0
                Exit Function
        End Select

    Case %WM_SIZE
       'Reset the viewport to new dimensions
        If HiWrd(lParam) < 1 Then lParam = (lParam Or &h00010000)
        glViewport 0, 0, CLng(LoWrd(lParam)), CLng(HiWrd(lParam))
        glMatrixMode GL_PROJECTION
        glLoadIdentity
        gluPerspective(45.0, CSng(LoWrd(lParam)/HiWrd(lParam)), 1.0, 1000.0)
        glMatrixMode GL_MODELVIEW
        glLoadIdentity
        Function = 0
        Exit Function

    Case Else
        Function = DefWindowProc(hWnd, wMsg, wParam, lParam)

    End Select

End Function

'-----------------------------------------------------------------------------------------
  Sub SetupPixelFormat(hDC As Dword)
      Local  nPixelFormat  As Long

      Static pfd As PIXELFORMATDESCRIPTOR
           pfd.nSize           = SizeOf(PIXELFORMATDESCRIPTOR) 'Size of UDT structure
           pfd.nVersion        = 1                             'Version. Always set to 1.
           pfd.dwFlags         = %PFD_DRAW_TO_WINDOW Or _      'Support Window
                                 %PFD_SUPPORT_OPENGL Or _      'Support OpenGL
                                 %PFD_DOUBLEBUFFER             'Support Double Buffering
           pfd.iPixelType      = %PFD_TYPE_RGBA                'Red, Green, Blue, & Alpha Mode
           pfd.cColorBits      = 32                            '32-Bit Color Mode
           pfd.cRedBits        = %NULL                         'Ignore Color and Shift Bits...
           pfd.cRedShift       = %NULL                         '...
           pfd.cGreenBits      = %NULL                         '...
           pfd.cGreenShift     = %NULL                         '...
           pfd.cBlueBits       = %NULL                         '...
           pfd.cBlueShift      = %NULL                         '...
           pfd.cAlphaBits      = %NULL                         'No Alpha Buffer
           pfd.cAlphaShift     = %NULL                         'Ignore Shift Bit.
           pfd.cAccumBits      = %NULL                         'No Accumulation Buffer
           pfd.cAccumRedBits   = %NULL                         'Ignore Accumulation Bits...
           pfd.cAccumGreenBits = %NULL                         '...
           pfd.cAccumBlueBits  = %NULL                         '...
           pfd.cAccumAlphaBits = %NULL                         '... Good Cereal! ;)
           pfd.cDepthBits      = 16                            '16-bit z-buffer depth
           pfd.cStencilBits    = %NULL                         'No Stencil Buffer
           pfd.cAuxBuffers     = %NULL                         'No Auxiliary Buffer
           pfd.iLayerType      = %PFD_MAIN_PLANE               'Main Drawing Plane
           pfd.bReserved       = %NULL                         'Reserved
           pfd.dwLayerMask     = %NULL                         'Ignore Layer Masks...
           pfd.dwVisibleMask   = %NULL                         '...
           pfd.dwDamageMask    = %NULL                         '...

   'Choose best matching pixel format, return index.
        nPixelFormat = ChoosePixelFormat(hDC, pfd)

   'Set pixel format to device context.
        SetPixelFormat(hDC, nPixelFormat, pfd)
End Sub
'-----------------------------------------------------------------------------------------
'-----------------------------------------------------------------------------------------
