'*********************************************************************************
'*  OpenGL "gl.inc" for PowerBASIC-Windows 7.0x                                  *
'*  Port Version 1.0d (March 28, 2003)                                           *
'*                                                                               *
'*  by Scott Martindale (smartndl@hotmail.com)                                   *
'*                                                                               *
'*  LEGAL:                                                                       *
'*  You have a royalty-free right to use, modify, reproduce and distribute this  *
'*  file (and/or any modified version) in any way you find useful, provided that *
'*  you agree that PowerBASIC, Silicon Graphics, present or future contributors  *
'*  have no warranty, obligation or liability for its contents.                  *
'*                                                                               *
'*  Original "gl.h": Copyright 1992-1998 Silicon Graphics, Inc.                  *
'*********************************************************************************

#IF NOT %DEF(%PB_GLinc)
%PB_GLinc = 1

'Datatypes

    MACRO GLenum     = DWORD   '32-Bit unsigned
    MACRO GLboolean  = BYTE    '8-Bit  unsigned
    MACRO GLbitfield = DWORD   '32-Bit unsigned
    MACRO GLbyte     = BYTE    '8-Bit  signed
    MACRO GLshort    = INTEGER '16-Bit signed
    MACRO GLint      = LONG    '32-Bit signed
    MACRO GLubyte    = BYTE    '8-Bit  unsigned
    MACRO GLushort   = WORD    '16-Bit unsigned
    MACRO GLuint     = DWORD   '32-Bit unsigned
    MACRO GLsizei    = LONG    '32-Bit signed
    MACRO GLfloat    = SINGLE  'single precision float
    MACRO GLclampf   = SINGLE  'single precision float in [0,1]
    MACRO GLdouble   = DOUBLE  'double precision float
    MACRO GLclampd   = DOUBLE  'double precision float in [0,1]
    MACRO GLvoid     = ANY     'No real need, but why not...
'*********************************************************************************

'** Extensions **
    MACRO GL_VERSION_1_1                      = 1
    MACRO GL_EXT_blend_color                  = 1
    MACRO GL_EXT_blend_minmax                 = 1
    MACRO GL_EXT_blend_subtract               = 1
    MACRO GL_EXT_abgr                         = 1
    MACRO GL_EXT_bgra                         = 1
    MACRO GL_EXT_clip_volume_hint             = 1
    MACRO GL_EXT_color_table                  = 1
    MACRO GL_EXT_convolution                  = 1
    MACRO GL_EXT_compiled_vertex_array        = 1
    MACRO GL_EXT_cull_vertex                  = 1
    MACRO GL_EXT_histogram                    = 1
    MACRO GL_EXT_packed_pixels                = 1
    MACRO GL_EXT_paletted_texture             = 1
    MACRO GL_EXT_polygon_offset               = 1
    MACRO GL_EXT_secondary_color              = 1
    MACRO GL_EXT_separate_specular_color      = 1
    MACRO GL_EXT_vertex_array                 = 1
    MACRO GL_WIN_swap_hint                    = 1

'** AttribMask **
    MACRO GL_CURRENT_BIT                      = &H00000001
    MACRO GL_POINT_BIT                        = &H00000002
    MACRO GL_LINE_BIT                         = &H00000004
    MACRO GL_POLYGON_BIT                      = &H00000008
    MACRO GL_POLYGON_STIPPLE_BIT              = &H00000010
    MACRO GL_PIXEL_MODE_BIT                   = &H00000020
    MACRO GL_LIGHTING_BIT                     = &H00000040
    MACRO GL_FOG_BIT                          = &H00000080
    MACRO GL_DEPTH_BUFFER_BIT                 = &H00000100
    MACRO GL_ACCUM_BUFFER_BIT                 = &H00000200
    MACRO GL_STENCIL_BUFFER_BIT               = &H00000400
    MACRO GL_VIEWPORT_BIT                     = &H00000800
    MACRO GL_TRANSFORM_BIT                    = &H00001000
    MACRO GL_ENABLE_BIT                       = &H00002000
    MACRO GL_COLOR_BUFFER_BIT                 = &H00004000
    MACRO GL_HINT_BIT                         = &H00008000
    MACRO GL_EVAL_BIT                         = &H00010000
    MACRO GL_LIST_BIT                         = &H00020000
    MACRO GL_TEXTURE_BIT                      = &H00040000
    MACRO GL_SCISSOR_BIT                      = &H00080000
    MACRO GL_ALL_ATTRIB_BITS                  = &H000fffff

'** ClientAttribMask **
    MACRO GL_CLIENT_PIXEL_STORE_BIT           = &H00000001
    MACRO GL_CLIENT_VERTEX_ARRAY_BIT          = &H00000002
    MACRO GL_CLIENT_ALL_ATTRIB_BITS           = &HFFFFFFFF

'** Boolean **
    MACRO GL_FALSE                            = 0
    MACRO GL_TRUE                             = 1

'** BeginMode **
    MACRO GL_POINTS                           = &H0000
    MACRO GL_LINES                            = &H0001
    MACRO GL_LINE_LOOP                        = &H0002
    MACRO GL_LINE_STRIP                       = &H0003
    MACRO GL_TRIANGLES                        = &H0004
    MACRO GL_TRIANGLE_STRIP                   = &H0005
    MACRO GL_TRIANGLE_FAN                     = &H0006
    MACRO GL_QUADS                            = &H0007
    MACRO GL_QUAD_STRIP                       = &H0008
    MACRO GL_POLYGON                          = &H0009

'** AccumOp **
    MACRO GL_ACCUM                            = &H0100
    MACRO GL_LOAD                             = &H0101
    MACRO GL_RETURN                           = &H0102
    MACRO GL_MULT                             = &H0103
    MACRO GL_ADD                              = &H0104

'** AlphaFunction **
    MACRO GL_NEVER                            = &H0200
    MACRO GL_LESS                             = &H0201
    MACRO GL_EQUAL                            = &H0202
    MACRO GL_LEQUAL                           = &H0203
    MACRO GL_GREATER                          = &H0204
    MACRO GL_NOTEQUAL                         = &H0205
    MACRO GL_GEQUAL                           = &H0206
    MACRO GL_ALWAYS                           = &H0207

'** BlendingFactorDest **
    MACRO GL_ZERO                             = 0
    MACRO GL_ONE                              = 1
    MACRO GL_SRC_COLOR                        = &H0300
    MACRO GL_ONE_MINUS_SRC_COLOR              = &H0301
    MACRO GL_SRC_ALPHA                        = &H0302
    MACRO GL_ONE_MINUS_SRC_ALPHA              = &H0303
    MACRO GL_DST_ALPHA                        = &H0304
    MACRO GL_ONE_MINUS_DST_ALPHA              = &H0305


'** BlendingFactorSrc **
    MACRO GL_DST_COLOR                        = &H0306
    MACRO GL_ONE_MINUS_DST_COLOR              = &H0307
    MACRO GL_SRC_ALPHA_SATURATE               = &H0308

'** DrawBufferMode **
    MACRO GL_NONE                             = 0
    MACRO GL_FRONT_LEFT                       = &H0400
    MACRO GL_FRONT_RIGHT                      = &H0401
    MACRO GL_BACK_LEFT                        = &H0402
    MACRO GL_BACK_RIGHT                       = &H0403
    MACRO GL_FRONT                            = &H0404
    MACRO GL_BACK                             = &H0405
    MACRO GL_LEFT                             = &H0406
    MACRO GL_RIGHT                            = &H0407
    MACRO GL_FRONT_AND_BACK                   = &H0408
    MACRO GL_AUX0                             = &H0409
    MACRO GL_AUX1                             = &H040A
    MACRO GL_AUX2                             = &H040B
    MACRO GL_AUX3                             = &H040C

'** ErrorCode **
    MACRO GL_NO_ERROR                         = 0
    MACRO GL_INVALID_ENUM                     = &H0500
    MACRO GL_INVALID_VALUE                    = &H0501
    MACRO GL_INVALID_OPERATION                = &H0502
    MACRO GL_STACK_OVERFLOW                   = &H0503
    MACRO GL_STACK_UNDERFLOW                  = &H0504
    MACRO GL_OUT_OF_MEMORY                    = &H0505


'** FeedbackType **
    MACRO GL_2D                               = &H0600
    MACRO GL_3D                               = &H0601
    MACRO GL_3D_COLOR                         = &H0602
    MACRO GL_3D_COLOR_TEXTURE                 = &H0603
    MACRO GL_4D_COLOR_TEXTURE                 = &H0604

'** FeedBackToken **
    MACRO GL_PASS_THROUGH_TOKEN               = &H0700
    MACRO GL_POINT_TOKEN                      = &H0701
    MACRO GL_LINE_TOKEN                       = &H0702
    MACRO GL_POLYGON_TOKEN                    = &H0703
    MACRO GL_BITMAP_TOKEN                     = &H0704
    MACRO GL_DRAW_PIXEL_TOKEN                 = &H0705
    MACRO GL_COPY_PIXEL_TOKEN                 = &H0706
    MACRO GL_LINE_RESET_TOKEN                 = &H0707

'** FogMode **
    MACRO GL_EXP                              = &H0800
    MACRO GL_EXP2                             = &H0801

'** FrontFaceDirection **
    MACRO GL_CW                               = &H0900
    MACRO GL_CCW                              = &H0901

'** GetMapQuery **
    MACRO GL_COEFF                            = &H0A00
    MACRO GL_ORDER                            = &H0A01
    MACRO GL_DOMAIN                           = &H0A02

'** GetPixelMap **
    MACRO GL_PIXEL_MAP_I_TO_I                 = &H0C70
    MACRO GL_PIXEL_MAP_S_TO_S                 = &H0C71
    MACRO GL_PIXEL_MAP_I_TO_R                 = &H0C72
    MACRO GL_PIXEL_MAP_I_TO_G                 = &H0C73
    MACRO GL_PIXEL_MAP_I_TO_B                 = &H0C74
    MACRO GL_PIXEL_MAP_I_TO_A                 = &H0C75
    MACRO GL_PIXEL_MAP_R_TO_R                 = &H0C76
    MACRO GL_PIXEL_MAP_G_TO_G                 = &H0C77
    MACRO GL_PIXEL_MAP_B_TO_B                 = &H0C78
    MACRO GL_PIXEL_MAP_A_TO_A                 = &H0C79

'** GetPointervPName **
    MACRO GL_VERTEX_ARRAY_POINTER             = &H808E
    MACRO GL_NORMAL_ARRAY_POINTER             = &H808F
    MACRO GL_COLOR_ARRAY_POINTER              = &H8090
    MACRO GL_INDEX_ARRAY_POINTER              = &H8091
    MACRO GL_TEXTURE_COORD_ARRAY_POINTER      = &H8092
    MACRO GL_EDGE_FLAG_ARRAY_POINTER          = &H8093

'** GetPName **
    MACRO GL_CURRENT_COLOR                    = &H0B00
    MACRO GL_CURRENT_INDEX                    = &H0B01
    MACRO GL_CURRENT_NORMAL                   = &H0B02
    MACRO GL_CURRENT_TEXTURE_COORDS           = &H0B03
    MACRO GL_CURRENT_RASTER_COLOR             = &H0B04
    MACRO GL_CURRENT_RASTER_INDEX             = &H0B05
    MACRO GL_CURRENT_RASTER_TEXTURE_COORDS    = &H0B06
    MACRO GL_CURRENT_RASTER_POSITION          = &H0B07
    MACRO GL_CURRENT_RASTER_POSITION_VALID    = &H0B08
    MACRO GL_CURRENT_RASTER_DISTANCE          = &H0B09
    MACRO GL_POINT_SMOOTH                     = &H0B10
    MACRO GL_POINT_SIZE                       = &H0B11
    MACRO GL_POINT_SIZE_RANGE                 = &H0B12
    MACRO GL_POINT_SIZE_GRANULARITY           = &H0B13
    MACRO GL_LINE_SMOOTH                      = &H0B20
    MACRO GL_LINE_WIDTH                       = &H0B21
    MACRO GL_LINE_WIDTH_RANGE                 = &H0B22
    MACRO GL_LINE_WIDTH_GRANULARITY           = &H0B23
    MACRO GL_LINE_STIPPLE                     = &H0B24
    MACRO GL_LINE_STIPPLE_PATTERN             = &H0B25
    MACRO GL_LINE_STIPPLE_REPEAT              = &H0B26
    MACRO GL_LIST_MODE                        = &H0B30
    MACRO GL_MAX_LIST_NESTING                 = &H0B31
    MACRO GL_LIST_BASE                        = &H0B32
    MACRO GL_LIST_INDEX                       = &H0B33
    MACRO GL_POLYGON_MODE                     = &H0B40
    MACRO GL_POLYGON_SMOOTH                   = &H0B41
    MACRO GL_POLYGON_STIPPLE                  = &H0B42
    MACRO GL_EDGE_FLAG                        = &H0B43
    MACRO GL_CULL_FACE                        = &H0B44
    MACRO GL_CULL_FACE_MODE                   = &H0B45
    MACRO GL_FRONT_FACE                       = &H0B46
    MACRO GL_LIGHTING                         = &H0B50
    MACRO GL_LIGHT_MODEL_LOCAL_VIEWER         = &H0B51
    MACRO GL_LIGHT_MODEL_TWO_SIDE             = &H0B52
    MACRO GL_LIGHT_MODEL_AMBIENT              = &H0B53
    MACRO GL_SHADE_MODEL                      = &H0B54
    MACRO GL_COLOR_MATERIAL_FACE              = &H0B55
    MACRO GL_COLOR_MATERIAL_PARAMETER         = &H0B56
    MACRO GL_COLOR_MATERIAL                   = &H0B57
    MACRO GL_FOG                              = &H0B60
    MACRO GL_FOG_INDEX                        = &H0B61
    MACRO GL_FOG_DENSITY                      = &H0B62
    MACRO GL_FOG_START                        = &H0B63
    MACRO GL_FOG_END                          = &H0B64
    MACRO GL_FOG_MODE                         = &H0B65
    MACRO GL_FOG_COLOR                        = &H0B66
    MACRO GL_DEPTH_RANGE                      = &H0B70
    MACRO GL_DEPTH_TEST                       = &H0B71
    MACRO GL_DEPTH_WRITEMASK                  = &H0B72
    MACRO GL_DEPTH_CLEAR_VALUE                = &H0B73
    MACRO GL_DEPTH_FUNC                       = &H0B74
    MACRO GL_ACCUM_CLEAR_VALUE                = &H0B80
    MACRO GL_STENCIL_TEST                     = &H0B90
    MACRO GL_STENCIL_CLEAR_VALUE              = &H0B91
    MACRO GL_STENCIL_FUNC                     = &H0B92
    MACRO GL_STENCIL_VALUE_MASK               = &H0B93
    MACRO GL_STENCIL_FAIL                     = &H0B94
    MACRO GL_STENCIL_PASS_DEPTH_FAIL          = &H0B95
    MACRO GL_STENCIL_PASS_DEPTH_PASS          = &H0B96
    MACRO GL_STENCIL_REF                      = &H0B97
    MACRO GL_STENCIL_WRITEMASK                = &H0B98
    MACRO GL_MATRIX_MODE                      = &H0BA0
    MACRO GL_NORMALIZE                        = &H0BA1
    MACRO GL_VIEWPORT                         = &H0BA2
    MACRO GL_MODELVIEW_STACK_DEPTH            = &H0BA3
    MACRO GL_PROJECTION_STACK_DEPTH           = &H0BA4
    MACRO GL_TEXTURE_STACK_DEPTH              = &H0BA5
    MACRO GL_MODELVIEW_MATRIX                 = &H0BA6
    MACRO GL_PROJECTION_MATRIX                = &H0BA7
    MACRO GL_TEXTURE_MATRIX                   = &H0BA8
    MACRO GL_ATTRIB_STACK_DEPTH               = &H0BB0
    MACRO GL_CLIENT_ATTRIB_STACK_DEPTH        = &H0BB1
    MACRO GL_ALPHA_TEST                       = &H0BC0
    MACRO GL_ALPHA_TEST_FUNC                  = &H0BC1
    MACRO GL_ALPHA_TEST_REF                   = &H0BC2
    MACRO GL_DITHER                           = &H0BD0
    MACRO GL_BLEND_DST                        = &H0BE0
    MACRO GL_BLEND_SRC                        = &H0BE1
    MACRO GL_BLEND                            = &H0BE2
    MACRO GL_LOGIC_OP_MODE                    = &H0BF0
    MACRO GL_INDEX_LOGIC_OP                   = &H0BF1
    MACRO GL_LOGIC_OP                         = GL_INDEX_LOGIC_OP
    MACRO GL_COLOR_LOGIC_OP                   = &H0BF2
    MACRO GL_AUX_BUFFERS                      = &H0C00
    MACRO GL_DRAW_BUFFER                      = &H0C01
    MACRO GL_READ_BUFFER                      = &H0C02
    MACRO GL_SCISSOR_BOX                      = &H0C10
    MACRO GL_SCISSOR_TEST                     = &H0C11
    MACRO GL_INDEX_CLEAR_VALUE                = &H0C20
    MACRO GL_INDEX_WRITEMASK                  = &H0C21
    MACRO GL_COLOR_CLEAR_VALUE                = &H0C22
    MACRO GL_COLOR_WRITEMASK                  = &H0C23
    MACRO GL_INDEX_MODE                       = &H0C30
    MACRO GL_RGBA_MODE                        = &H0C31
    MACRO GL_DOUBLEBUFFER                     = &H0C32
    MACRO GL_STEREO                           = &H0C33
    MACRO GL_RENDER_MODE                      = &H0C40
    MACRO GL_PERSPECTIVE_CORRECTION_HINT      = &H0C50
    MACRO GL_POINT_SMOOTH_HINT                = &H0C51
    MACRO GL_LINE_SMOOTH_HINT                 = &H0C52
    MACRO GL_POLYGON_SMOOTH_HINT              = &H0C53
    MACRO GL_FOG_HINT                         = &H0C54
    MACRO GL_TEXTURE_GEN_S                    = &H0C60
    MACRO GL_TEXTURE_GEN_T                    = &H0C61
    MACRO GL_TEXTURE_GEN_R                    = &H0C62
    MACRO GL_TEXTURE_GEN_Q                    = &H0C63
    MACRO GL_PIXEL_MAP_I_TO_I_SIZE            = &H0CB0
    MACRO GL_PIXEL_MAP_S_TO_S_SIZE            = &H0CB1
    MACRO GL_PIXEL_MAP_I_TO_R_SIZE            = &H0CB2
    MACRO GL_PIXEL_MAP_I_TO_G_SIZE            = &H0CB3
    MACRO GL_PIXEL_MAP_I_TO_B_SIZE            = &H0CB4
    MACRO GL_PIXEL_MAP_I_TO_A_SIZE            = &H0CB5
    MACRO GL_PIXEL_MAP_R_TO_R_SIZE            = &H0CB6
    MACRO GL_PIXEL_MAP_G_TO_G_SIZE            = &H0CB7
    MACRO GL_PIXEL_MAP_B_TO_B_SIZE            = &H0CB8
    MACRO GL_PIXEL_MAP_A_TO_A_SIZE            = &H0CB9
    MACRO GL_UNPACK_SWAP_BYTES                = &H0CF0
    MACRO GL_UNPACK_LSB_FIRST                 = &H0CF1
    MACRO GL_UNPACK_ROW_LENGTH                = &H0CF2
    MACRO GL_UNPACK_SKIP_ROWS                 = &H0CF3
    MACRO GL_UNPACK_SKIP_PIXELS               = &H0CF4
    MACRO GL_UNPACK_ALIGNMENT                 = &H0CF5
    MACRO GL_PACK_SWAP_BYTES                  = &H0D00
    MACRO GL_PACK_LSB_FIRST                   = &H0D01
    MACRO GL_PACK_ROW_LENGTH                  = &H0D02
    MACRO GL_PACK_SKIP_ROWS                   = &H0D03
    MACRO GL_PACK_SKIP_PIXELS                 = &H0D04
    MACRO GL_PACK_ALIGNMENT                   = &H0D05
    MACRO GL_MAP_COLOR                        = &H0D10
    MACRO GL_MAP_STENCIL                      = &H0D11
    MACRO GL_INDEX_SHIFT                      = &H0D12
    MACRO GL_INDEX_OFFSET                     = &H0D13
    MACRO GL_RED_SCALE                        = &H0D14
    MACRO GL_RED_BIAS                         = &H0D15
    MACRO GL_ZOOM_X                           = &H0D16
    MACRO GL_ZOOM_Y                           = &H0D17
    MACRO GL_GREEN_SCALE                      = &H0D18
    MACRO GL_GREEN_BIAS                       = &H0D19
    MACRO GL_BLUE_SCALE                       = &H0D1A
    MACRO GL_BLUE_BIAS                        = &H0D1B
    MACRO GL_ALPHA_SCALE                      = &H0D1C
    MACRO GL_ALPHA_BIAS                       = &H0D1D
    MACRO GL_DEPTH_SCALE                      = &H0D1E
    MACRO GL_DEPTH_BIAS                       = &H0D1F
    MACRO GL_MAX_EVAL_ORDER                   = &H0D30
    MACRO GL_MAX_LIGHTS                       = &H0D31
    MACRO GL_MAX_CLIP_PLANES                  = &H0D32
    MACRO GL_MAX_TEXTURE_SIZE                 = &H0D33
    MACRO GL_MAX_PIXEL_MAP_TABLE              = &H0D34
    MACRO GL_MAX_ATTRIB_STACK_DEPTH           = &H0D35
    MACRO GL_MAX_MODELVIEW_STACK_DEPTH        = &H0D36
    MACRO GL_MAX_NAME_STACK_DEPTH             = &H0D37
    MACRO GL_MAX_PROJECTION_STACK_DEPTH       = &H0D38
    MACRO GL_MAX_TEXTURE_STACK_DEPTH          = &H0D39
    MACRO GL_MAX_VIEWPORT_DIMS                = &H0D3A
    MACRO GL_MAX_CLIENT_ATTRIB_STACK_DEPTH    = &H0D3B
    MACRO GL_SUBPIXEL_BITS                    = &H0D50
    MACRO GL_INDEX_BITS                       = &H0D51
    MACRO GL_RED_BITS                         = &H0D52
    MACRO GL_GREEN_BITS                       = &H0D53
    MACRO GL_BLUE_BITS                        = &H0D54
    MACRO GL_ALPHA_BITS                       = &H0D55
    MACRO GL_DEPTH_BITS                       = &H0D56
    MACRO GL_STENCIL_BITS                     = &H0D57
    MACRO GL_ACCUM_RED_BITS                   = &H0D58
    MACRO GL_ACCUM_GREEN_BITS                 = &H0D59
    MACRO GL_ACCUM_BLUE_BITS                  = &H0D5A
    MACRO GL_ACCUM_ALPHA_BITS                 = &H0D5B
    MACRO GL_NAME_STACK_DEPTH                 = &H0D70
    MACRO GL_AUTO_NORMAL                      = &H0D80
    MACRO GL_MAP1_COLOR_4                     = &H0D90
    MACRO GL_MAP1_INDEX                       = &H0D91
    MACRO GL_MAP1_NORMAL                      = &H0D92
    MACRO GL_MAP1_TEXTURE_COORD_1             = &H0D93
    MACRO GL_MAP1_TEXTURE_COORD_2             = &H0D94
    MACRO GL_MAP1_TEXTURE_COORD_3             = &H0D95
    MACRO GL_MAP1_TEXTURE_COORD_4             = &H0D96
    MACRO GL_MAP1_VERTEX_3                    = &H0D97
    MACRO GL_MAP1_VERTEX_4                    = &H0D98
    MACRO GL_MAP2_COLOR_4                     = &H0DB0
    MACRO GL_MAP2_INDEX                       = &H0DB1
    MACRO GL_MAP2_NORMAL                      = &H0DB2
    MACRO GL_MAP2_TEXTURE_COORD_1             = &H0DB3
    MACRO GL_MAP2_TEXTURE_COORD_2             = &H0DB4
    MACRO GL_MAP2_TEXTURE_COORD_3             = &H0DB5
    MACRO GL_MAP2_TEXTURE_COORD_4             = &H0DB6
    MACRO GL_MAP2_VERTEX_3                    = &H0DB7
    MACRO GL_MAP2_VERTEX_4                    = &H0DB8
    MACRO GL_MAP1_GRID_DOMAIN                 = &H0DD0
    MACRO GL_MAP1_GRID_SEGMENTS               = &H0DD1
    MACRO GL_MAP2_GRID_DOMAIN                 = &H0DD2
    MACRO GL_MAP2_GRID_SEGMENTS               = &H0DD3
    MACRO GL_TEXTURE_1D                       = &H0DE0
    MACRO GL_TEXTURE_2D                       = &H0DE1
    MACRO GL_FEEDBACK_BUFFER_POINTER          = &H0DF0
    MACRO GL_FEEDBACK_BUFFER_SIZE             = &H0DF1
    MACRO GL_FEEDBACK_BUFFER_TYPE             = &H0DF2
    MACRO GL_SELECTION_BUFFER_POINTER         = &H0DF3
    MACRO GL_SELECTION_BUFFER_SIZE            = &H0DF4
    MACRO GL_POLYGON_OFFSET_UNITS             = &H2A00
    MACRO GL_POLYGON_OFFSET_POINT             = &H2A01
    MACRO GL_POLYGON_OFFSET_LINE              = &H2A02
    MACRO GL_POLYGON_OFFSET_FILL              = &H8037
    MACRO GL_POLYGON_OFFSET_FACTOR            = &H8038
    MACRO GL_TEXTURE_BINDING_1D               = &H8068
    MACRO GL_TEXTURE_BINDING_2D               = &H8069
    MACRO GL_VERTEX_ARRAY                     = &H8074
    MACRO GL_NORMAL_ARRAY                     = &H8075
    MACRO GL_COLOR_ARRAY                      = &H8076
    MACRO GL_INDEX_ARRAY                      = &H8077
    MACRO GL_TEXTURE_COORD_ARRAY              = &H8078
    MACRO GL_EDGE_FLAG_ARRAY                  = &H8079
'**      GL_SECONDARY_COLOR_ARRAY_EXT **
    MACRO GL_VERTEX_ARRAY_SIZE                = &H807A
    MACRO GL_VERTEX_ARRAY_TYPE                = &H807B
    MACRO GL_VERTEX_ARRAY_STRIDE              = &H807C
    MACRO GL_NORMAL_ARRAY_TYPE                = &H807E
    MACRO GL_NORMAL_ARRAY_STRIDE              = &H807F
    MACRO GL_COLOR_ARRAY_SIZE                 = &H8081
    MACRO GL_COLOR_ARRAY_TYPE                 = &H8082
    MACRO GL_COLOR_ARRAY_STRIDE               = &H8083
    MACRO GL_INDEX_ARRAY_TYPE                 = &H8085
    MACRO GL_INDEX_ARRAY_STRIDE               = &H8086
    MACRO GL_TEXTURE_COORD_ARRAY_SIZE         = &H8088
    MACRO GL_TEXTURE_COORD_ARRAY_TYPE         = &H8089
    MACRO GL_TEXTURE_COORD_ARRAY_STRIDE       = &H808A
    MACRO GL_EDGE_FLAG_ARRAY_STRIDE           = &H808C


'** GetTextureParameter **
    MACRO GL_TEXTURE_WIDTH                    = &H1000
    MACRO GL_TEXTURE_HEIGHT                   = &H1001
    MACRO GL_TEXTURE_INTERNAL_FORMAT          = &H1003
    MACRO GL_TEXTURE_COMPONENTS               = GL_TEXTURE_INTERNAL_FORMAT
    MACRO GL_TEXTURE_BORDER_COLOR             = &H1004
    MACRO GL_TEXTURE_BORDER                   = &H1005
    MACRO GL_TEXTURE_RED_SIZE                 = &H805C
    MACRO GL_TEXTURE_GREEN_SIZE               = &H805D
    MACRO GL_TEXTURE_BLUE_SIZE                = &H805E
    MACRO GL_TEXTURE_ALPHA_SIZE               = &H805F
    MACRO GL_TEXTURE_LUMINANCE_SIZE           = &H8060
    MACRO GL_TEXTURE_INTENSITY_SIZE           = &H8061
    MACRO GL_TEXTURE_PRIORITY                 = &H8066
    MACRO GL_TEXTURE_RESIDENT                 = &H8067

'** HintMode **
    MACRO GL_DONT_CARE                        = &H1100
    MACRO GL_FASTEST                          = &H1101
    MACRO GL_NICEST                           = &H1102

'** LightParameter **
    MACRO GL_AMBIENT                          = &H1200
    MACRO GL_DIFFUSE                          = &H1201
    MACRO GL_SPECULAR                         = &H1202
    MACRO GL_POSITION                         = &H1203
    MACRO GL_SPOT_DIRECTION                   = &H1204
    MACRO GL_SPOT_EXPONENT                    = &H1205
    MACRO GL_SPOT_CUTOFF                      = &H1206
    MACRO GL_CONSTANT_ATTENUATION             = &H1207
    MACRO GL_LINEAR_ATTENUATION               = &H1208
    MACRO GL_QUADRATIC_ATTENUATION            = &H1209

'** ListMode **
    MACRO GL_COMPILE                          = &H1300
    MACRO GL_COMPILE_AND_EXECUTE              = &H1301

'** DataType **
    MACRO GL_BYTE                             = &H1400
    MACRO GL_UNSIGNED_BYTE                    = &H1401
    MACRO GL_SHORT                            = &H1402
    MACRO GL_UNSIGNED_SHORT                   = &H1403
    MACRO GL_INT                              = &H1404
    MACRO GL_UNSIGNED_INT                     = &H1405
    MACRO GL_FLOAT                            = &H1406
    MACRO GL_2_BYTES                          = &H1407
    MACRO GL_3_BYTES                          = &H1408
    MACRO GL_4_BYTES                          = &H1409
    MACRO GL_DOUBLE                           = &H140A
    MACRO GL_DOUBLE_EXT                       = &H140A

'** LogicOp **
    MACRO GL_CLEAR                            = &H1500
    MACRO GL_AND                              = &H1501
    MACRO GL_AND_REVERSE                      = &H1502
    MACRO GL_COPY                             = &H1503
    MACRO GL_AND_INVERTED                     = &H1504
    MACRO GL_NOOP                             = &H1505
    MACRO GL_XOR                              = &H1506
    MACRO GL_OR                               = &H1507
    MACRO GL_NOR                              = &H1508
    MACRO GL_EQUIV                            = &H1509
    MACRO GL_INVERT                           = &H150A
    MACRO GL_OR_REVERSE                       = &H150B
    MACRO GL_COPY_INVERTED                    = &H150C
    MACRO GL_OR_INVERTED                      = &H150D
    MACRO GL_NAND                             = &H150E
    MACRO GL_SET                              = &H150F

'** MaterialParameter **
    MACRO GL_EMISSION                         = &H1600
    MACRO GL_SHININESS                        = &H1601
    MACRO GL_AMBIENT_AND_DIFFUSE              = &H1602
    MACRO GL_COLOR_INDEXES                    = &H1603

'** MatrixMode **
    MACRO GL_MODELVIEW                        = &H1700
    MACRO GL_PROJECTION                       = &H1701
    MACRO GL_TEXTURE                          = &H1702

'** PixelCopyType **
    MACRO GL_COLOR                            = &H1800
    MACRO GL_DEPTH                            = &H1801
    MACRO GL_STENCIL                          = &H1802

'** PixelFormat **
    MACRO GL_COLOR_INDEX                      = &H1900
    MACRO GL_STENCIL_INDEX                    = &H1901
    MACRO GL_DEPTH_COMPONENT                  = &H1902
    MACRO GL_RED                              = &H1903
    MACRO GL_GREEN                            = &H1904
    MACRO GL_BLUE                             = &H1905
    MACRO GL_ALPHA                            = &H1906
    MACRO GL_RGB                              = &H1907
    MACRO GL_RGBA                             = &H1908
    MACRO GL_LUMINANCE                        = &H1909
    MACRO GL_LUMINANCE_ALPHA                  = &H190A

'** PixelType **
    MACRO GL_BITMAP                           = &H1A00


'** PolygonMode **
    MACRO GL_POINT                            = &H1B00
    MACRO GL_LINE                             = &H1B01
    MACRO GL_FILL                             = &H1B02

'** RenderingMode **
    MACRO GL_RENDER                           = &H1C00
    MACRO GL_FEEDBACK                         = &H1C01
    MACRO GL_SELECT                           = &H1C02

'** ShadingModel **
    MACRO GL_FLAT                             = &H1D00
    MACRO GL_SMOOTH                           = &H1D01

'** StencilOp **
    MACRO GL_KEEP                             = &H1E00
    MACRO GL_REPLACE                          = &H1E01
    MACRO GL_INCR                             = &H1E02
    MACRO GL_DECR                             = &H1E03

'** StringName **
    MACRO GL_VENDOR                           = &H1F00
    MACRO GL_RENDERER                         = &H1F01
    MACRO GL_VERSION                          = &H1F02
    MACRO GL_EXTENSIONS                       = &H1F03

'** TextureCoordName **
    MACRO GL_S                                = &H2000
    MACRO GL_T                                = &H2001
    MACRO GL_R                                = &H2002
    MACRO GL_Q                                = &H2003

'** TextureEnvMode **
    MACRO GL_MODULATE                         = &H2100
    MACRO GL_DECAL                            = &H2101


'** TextureEnvParameter **
    MACRO GL_TEXTURE_ENV_MODE                 = &H2200
    MACRO GL_TEXTURE_ENV_COLOR                = &H2201

'** TextureEnvTarget **
    MACRO GL_TEXTURE_ENV                      = &H2300

'** TextureGenMode **
    MACRO GL_EYE_LINEAR                       = &H2400
    MACRO GL_OBJECT_LINEAR                    = &H2401
    MACRO GL_SPHERE_MAP                       = &H2402

'** TextureGenParameter **
    MACRO GL_TEXTURE_GEN_MODE                 = &H2500
    MACRO GL_OBJECT_PLANE                     = &H2501
    MACRO GL_EYE_PLANE                        = &H2502

'** TextureMagFilter **
    MACRO GL_NEAREST                          = &H2600
    MACRO GL_LINEAR                           = &H2601

'** TextureMinFilter **
    MACRO GL_NEAREST_MIPMAP_NEAREST           = &H2700
    MACRO GL_LINEAR_MIPMAP_NEAREST            = &H2701
    MACRO GL_NEAREST_MIPMAP_LINEAR            = &H2702
    MACRO GL_LINEAR_MIPMAP_LINEAR             = &H2703

'** TextureParameterName **
    MACRO GL_TEXTURE_MAG_FILTER               = &H2800
    MACRO GL_TEXTURE_MIN_FILTER               = &H2801
    MACRO GL_TEXTURE_WRAP_S                   = &H2802
    MACRO GL_TEXTURE_WRAP_T                   = &H2803


'** TextureTarget **
    MACRO GL_PROXY_TEXTURE_1D                 = &H8063
    MACRO GL_PROXY_TEXTURE_2D                 = &H8064

'** TextureWrapMode **
    MACRO GL_CLAMP                            = &H2900
    MACRO GL_REPEAT                           = &H2901

'** PixelInternalFormat **
    MACRO GL_R3_G3_B2                         = &H2A10
    MACRO GL_ALPHA4                           = &H803B
    MACRO GL_ALPHA8                           = &H803C
    MACRO GL_ALPHA12                          = &H803D
    MACRO GL_ALPHA16                          = &H803E
    MACRO GL_LUMINANCE4                       = &H803F
    MACRO GL_LUMINANCE8                       = &H8040
    MACRO GL_LUMINANCE12                      = &H8041
    MACRO GL_LUMINANCE16                      = &H8042
    MACRO GL_LUMINANCE4_ALPHA4                = &H8043
    MACRO GL_LUMINANCE6_ALPHA2                = &H8044
    MACRO GL_LUMINANCE8_ALPHA8                = &H8045
    MACRO GL_LUMINANCE12_ALPHA4               = &H8046
    MACRO GL_LUMINANCE12_ALPHA12              = &H8047
    MACRO GL_LUMINANCE16_ALPHA16              = &H8048
    MACRO GL_INTENSITY                        = &H8049
    MACRO GL_INTENSITY4                       = &H804A
    MACRO GL_INTENSITY8                       = &H804B
    MACRO GL_INTENSITY12                      = &H804C
    MACRO GL_INTENSITY16                      = &H804D
    MACRO GL_RGB4                             = &H804F
    MACRO GL_RGB5                             = &H8050
    MACRO GL_RGB8                             = &H8051
    MACRO GL_RGB10                            = &H8052
    MACRO GL_RGB12                            = &H8053
    MACRO GL_RGB16                            = &H8054
    MACRO GL_RGBA2                            = &H8055
    MACRO GL_RGBA4                            = &H8056
    MACRO GL_RGB5_A1                          = &H8057
    MACRO GL_RGBA8                            = &H8058
    MACRO GL_RGB10_A2                         = &H8059
    MACRO GL_RGBA12                           = &H805A
    MACRO GL_RGBA16                           = &H805B


'** InterleavedArrayFormat **
    MACRO GL_V2F                              = &H2A20
    MACRO GL_V3F                              = &H2A21
    MACRO GL_C4UB_V2F                         = &H2A22
    MACRO GL_C4UB_V3F                         = &H2A23
    MACRO GL_C3F_V3F                          = &H2A24
    MACRO GL_N3F_V3F                          = &H2A25
    MACRO GL_C4F_N3F_V3F                      = &H2A26
    MACRO GL_T2F_V3F                          = &H2A27
    MACRO GL_T4F_V4F                          = &H2A28
    MACRO GL_T2F_C4UB_V3F                     = &H2A29
    MACRO GL_T2F_C3F_V3F                      = &H2A2A
    MACRO GL_T2F_N3F_V3F                      = &H2A2B
    MACRO GL_T2F_C4F_N3F_V3F                  = &H2A2C
    MACRO GL_T4F_C4F_N3F_V4F                  = &H2A2D

'** ClipPlaneName **
    MACRO GL_CLIP_PLANE0                      = &H3000
    MACRO GL_CLIP_PLANE1                      = &H3001
    MACRO GL_CLIP_PLANE2                      = &H3002
    MACRO GL_CLIP_PLANE3                      = &H3003
    MACRO GL_CLIP_PLANE4                      = &H3004
    MACRO GL_CLIP_PLANE5                      = &H3005

'** LightName **
    MACRO GL_LIGHT0                           = &H4000
    MACRO GL_LIGHT1                           = &H4001
    MACRO GL_LIGHT2                           = &H4002
    MACRO GL_LIGHT3                           = &H4003
    MACRO GL_LIGHT4                           = &H4004
    MACRO GL_LIGHT5                           = &H4005
    MACRO GL_LIGHT6                           = &H4006
    MACRO GL_LIGHT7                           = &H4007

'** EXT_abgr **
    MACRO GL_ABGR_EXT                         = &H8000

'** EXT_blend_color **
    MACRO GL_CONSTANT_COLOR_EXT               = &H8001
    MACRO GL_ONE_MINUS_CONSTANT_COLOR_EXT     = &H8002
    MACRO GL_CONSTANT_ALPHA_EXT               = &H8003
    MACRO GL_ONE_MINUS_CONSTANT_ALPHA_EXT     = &H8004
    MACRO GL_BLEND_COLOR_EXT                  = &H8005

'** EXT_blend_minmax **
    MACRO GL_FUNC_ADD_EXT                     = &H8006
    MACRO GL_MIN_EXT                          = &H8007
    MACRO GL_MAX_EXT                          = &H8008
    MACRO GL_BLEND_EQUATION_EXT               = &H8009

'** EXT_blend_subtract **
    MACRO GL_FUNC_SUBTRACT_EXT                = &H800A
    MACRO GL_FUNC_REVERSE_SUBTRACT_EXT        = &H800B

'** EXT_convolution **
    MACRO GL_CONVOLUTION_1D_EXT               = &H8010
    MACRO GL_CONVOLUTION_2D_EXT               = &H8011
    MACRO GL_SEPARABLE_2D_EXT                 = &H8012
    MACRO GL_CONVOLUTION_BORDER_MODE_EXT      = &H8013
    MACRO GL_CONVOLUTION_FILTER_SCALE_EXT     = &H8014
    MACRO GL_CONVOLUTION_FILTER_BIAS_EXT      = &H8015
    MACRO GL_REDUCE_EXT                       = &H8016
    MACRO GL_CONVOLUTION_FORMAT_EXT           = &H8017
    MACRO GL_CONVOLUTION_WIDTH_EXT            = &H8018
    MACRO GL_CONVOLUTION_HEIGHT_EXT           = &H8019
    MACRO GL_MAX_CONVOLUTION_WIDTH_EXT        = &H801A
    MACRO GL_MAX_CONVOLUTION_HEIGHT_EXT       = &H801B
    MACRO GL_POST_CONVOLUTION_RED_SCALE_EXT   = &H801C
    MACRO GL_POST_CONVOLUTION_GREEN_SCALE_EXT = &H801D
    MACRO GL_POST_CONVOLUTION_BLUE_SCALE_EXT  = &H801E
    MACRO GL_POST_CONVOLUTION_ALPHA_SCALE_EXT = &H801F
    MACRO GL_POST_CONVOLUTION_RED_BIAS_EXT    = &H8020
    MACRO GL_POST_CONVOLUTION_GREEN_BIAS_EXT  = &H8021
    MACRO GL_POST_CONVOLUTION_BLUE_BIAS_EXT   = &H8022
    MACRO GL_POST_CONVOLUTION_ALPHA_BIAS_EXT  = &H8023

'** EXT_histogram **
    MACRO GL_HISTOGRAM_EXT                    = &H8024
    MACRO GL_PROXY_HISTOGRAM_EXT              = &H8025
    MACRO GL_HISTOGRAM_WIDTH_EXT              = &H8026
    MACRO GL_HISTOGRAM_FORMAT_EXT             = &H8027
    MACRO GL_HISTOGRAM_RED_SIZE_EXT           = &H8028
    MACRO GL_HISTOGRAM_GREEN_SIZE_EXT         = &H8029
    MACRO GL_HISTOGRAM_BLUE_SIZE_EXT          = &H802A
    MACRO GL_HISTOGRAM_ALPHA_SIZE_EXT         = &H802B
    MACRO GL_HISTOGRAM_LUMINANCE_SIZE_EXT     = &H802C
    MACRO GL_HISTOGRAM_SINK_EXT               = &H802D
    MACRO GL_MINMAX_EXT                       = &H802E
    MACRO GL_MINMAX_FORMAT_EXT                = &H802F
    MACRO GL_MINMAX_SINK_EXT                  = &H8030

'** EXT_polygon_offset **
    MACRO GL_POLYGON_OFFSET_EXT               = &H8037
    MACRO GL_POLYGON_OFFSET_FACTOR_EXT        = &H8038
    MACRO GL_POLYGON_OFFSET_BIAS_EXT          = &H8039

'** EXT_packed_pixels **
    MACRO GL_UNSIGNED_BYTE_3_3_2_EXT          = &H8032
    MACRO GL_UNSIGNED_SHORT_4_4_4_4_EXT       = &H8033
    MACRO GL_UNSIGNED_SHORT_5_5_5_1_EXT       = &H8034
    MACRO GL_UNSIGNED_INT_8_8_8_8_EXT         = &H8035
    MACRO GL_UNSIGNED_INT_10_10_10_2_EXT      = &H8036

'** EXT_vertex_array **
    MACRO GL_VERTEX_ARRAY_EXT                 = &H8074
    MACRO GL_NORMAL_ARRAY_EXT                 = &H8075
    MACRO GL_COLOR_ARRAY_EXT                  = &H8076
    MACRO GL_INDEX_ARRAY_EXT                  = &H8077
    MACRO GL_TEXTURE_COORD_ARRAY_EXT          = &H8078
    MACRO GL_EDGE_FLAG_ARRAY_EXT              = &H8079
    MACRO GL_VERTEX_ARRAY_SIZE_EXT            = &H807A
    MACRO GL_VERTEX_ARRAY_TYPE_EXT            = &H807B
    MACRO GL_VERTEX_ARRAY_STRIDE_EXT          = &H807C
    MACRO GL_VERTEX_ARRAY_COUNT_EXT           = &H807D
    MACRO GL_NORMAL_ARRAY_TYPE_EXT            = &H807E
    MACRO GL_NORMAL_ARRAY_STRIDE_EXT          = &H807F
    MACRO GL_NORMAL_ARRAY_COUNT_EXT           = &H8080
    MACRO GL_COLOR_ARRAY_SIZE_EXT             = &H8081
    MACRO GL_COLOR_ARRAY_TYPE_EXT             = &H8082
    MACRO GL_COLOR_ARRAY_STRIDE_EXT           = &H8083
    MACRO GL_COLOR_ARRAY_COUNT_EXT            = &H8084
    MACRO GL_INDEX_ARRAY_TYPE_EXT             = &H8085
    MACRO GL_INDEX_ARRAY_STRIDE_EXT           = &H8086
    MACRO GL_INDEX_ARRAY_COUNT_EXT            = &H8087
    MACRO GL_TEXTURE_COORD_ARRAY_SIZE_EXT     = &H8088
    MACRO GL_TEXTURE_COORD_ARRAY_TYPE_EXT     = &H8089
    MACRO GL_TEXTURE_COORD_ARRAY_STRIDE_EXT   = &H808A
    MACRO GL_TEXTURE_COORD_ARRAY_COUNT_EXT    = &H808B
    MACRO GL_EDGE_FLAG_ARRAY_STRIDE_EXT       = &H808C
    MACRO GL_EDGE_FLAG_ARRAY_COUNT_EXT        = &H808D
    MACRO GL_VERTEX_ARRAY_POINTER_EXT         = &H808E
    MACRO GL_NORMAL_ARRAY_POINTER_EXT         = &H808F
    MACRO GL_COLOR_ARRAY_POINTER_EXT          = &H8090
    MACRO GL_INDEX_ARRAY_POINTER_EXT          = &H8091
    MACRO GL_TEXTURE_COORD_ARRAY_POINTER_EXT  = &H8092
    MACRO GL_EDGE_FLAG_ARRAY_POINTER_EXT      = &H8093

'** EXT_color_table **
    MACRO GL_TABLE_TOO_LARGE_EXT                     = &H8031
    MACRO GL_COLOR_TABLE_EXT                         = &H80D0
    MACRO GL_POST_CONVOLUTION_COLOR_TABLE_EXT        = &H80D1
    MACRO GL_POST_COLOR_MATRIX_COLOR_TABLE_EXT       = &H80D2
    MACRO GL_PROXY_COLOR_TABLE_EXT                   = &H80D3
    MACRO GL_PROXY_POST_CONVOLUTION_COLOR_TABLE_EXT  = &H80D4
    MACRO GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE_EXT = &H80D5
    MACRO GL_COLOR_TABLE_SCALE_EXT                   = &H80D6
    MACRO GL_COLOR_TABLE_BIAS_EXT                    = &H80D7
    MACRO GL_COLOR_TABLE_FORMAT_EXT                  = &H80D8
    MACRO GL_COLOR_TABLE_WIDTH_EXT                   = &H80D9
    MACRO GL_COLOR_TABLE_RED_SIZE_EXT                = &H80DA
    MACRO GL_COLOR_TABLE_GREEN_SIZE_EXT              = &H80DB
    MACRO GL_COLOR_TABLE_BLUE_SIZE_EXT               = &H80DC
    MACRO GL_COLOR_TABLE_ALPHA_SIZE_EXT              = &H80DD
    MACRO GL_COLOR_TABLE_LUMINANCE_SIZE_EXT          = &H80DE
    MACRO GL_COLOR_TABLE_INTENSITY_SIZE_EXT          = &H80DF

'** EXT_bgra **
    MACRO GL_BGR_EXT                          = &H80E0
    MACRO GL_BGRA_EXT                         = &H80E1

'** EXT_paletted_texture **
    MACRO GL_COLOR_INDEX1_EXT                 = &H80E2
    MACRO GL_COLOR_INDEX2_EXT                 = &H80E3
    MACRO GL_COLOR_INDEX4_EXT                 = &H80E4
    MACRO GL_COLOR_INDEX8_EXT                 = &H80E5
    MACRO GL_COLOR_INDEX12_EXT                = &H80E6
    MACRO GL_COLOR_INDEX16_EXT                = &H80E7

'** EXT_separate_specular_color **
    MACRO GL_LIGHT_MODEL_COLOR_CONTROL_EXT    = &H81F8
    MACRO GL_SINGLE_COLOR_EXT                 = &H81F9
    MACRO GL_SEPARATE_SPECULAR_COLOR_EXT      = &H81FA

'** EXT_secondary_color **
    MACRO GL_COLOR_SUM_EXT                     = &H8458
    MACRO GL_CURRENT_SECONDARY_COLOR_EXT       = &H8459
    MACRO GL_SECONDARY_COLOR_ARRAY_SIZE_EXT    = &H845A
    MACRO GL_SECONDARY_COLOR_ARRAY_TYPE_EXT    = &H845B
    MACRO GL_SECONDARY_COLOR_ARRAY_STRIDE_EXT  = &H845C
    MACRO GL_SECONDARY_COLOR_ARRAY_POINTER_EXT = &H845D
    MACRO GL_SECONDARY_COLOR_ARRAY_EXT         = &H845E

'** EXT_clip_volume_hint **
    MACRO GL_CLIP_VOLUME_CLIPPING_HINT_EXT    = &H80F0

'** EXT_compiled_vertex_array **
    MACRO GL_ARRAY_ELEMENT_LOCK_FIRST_EXT     = &H81A8
    MACRO GL_ARRAY_ELEMENT_LOCK_COUNT_EXT     = &H81A9

'** EXT_cull_vertex **
    MACRO GL_CULL_VERTEX_EXT                  = &H81AA
    MACRO GL_CULL_VERTEX_EYE_POSITION_EXT     = &H81AB
    MACRO GL_CULL_VERTEX_OBJECT_POSITION_EXT  = &H81AC

'*********************************************************************************
'*  OpenGL Function and Subroutine Declarations:

DECLARE SUB glAccum LIB "opengl32.dll" ALIAS "glAccum" (BYVAL op AS GLenum, BYVAL value AS GLfloat)
DECLARE SUB glAlphaFunc LIB "opengl32.dll" ALIAS "glAlphaFunc" (BYVAL func AS GLenum, BYVAL ref AS GLclampf)
DECLARE FUNCTION glAreTexturesResident LIB "opengl32.dll" ALIAS "glAreTexturesResident"_
(BYVAL n AS GLsizei, BYREF textures AS GLuint, BYREF residences AS GLboolean) AS GLboolean
DECLARE SUB glArrayElement LIB "opengl32.dll" ALIAS "glArrayElement" (BYVAL i AS GLint)
DECLARE SUB glBegin LIB "opengl32.dll" ALIAS "glBegin" (BYVAL mode AS GLenum)
DECLARE SUB glBindTexture LIB "opengl32.dll" ALIAS "glBindTexture" (BYVAL ntarget AS GLenum, BYVAL texture AS GLuint)
DECLARE SUB glBitmap LIB "opengl32.dll" ALIAS "glBitmap" (BYVAL nwidth AS GLsizei, BYVAL height AS GLsizei, _
            BYVAL xorig AS GLfloat, BYVAL yorig AS GLfloat, BYVAL xmove AS GLfloat, BYVAL ymove AS GLfloat, BYREF nbitmap AS GLubyte)
DECLARE SUB glBlendFunc LIB "opengl32.dll" ALIAS "glBlendFunc" (BYVAL sfactor AS GLenum, BYVAL dfactor AS GLenum)
DECLARE SUB glCallList LIB "opengl32.dll" ALIAS "glCallList" (BYVAL list AS GLuint)
DECLARE SUB glCallLists LIB "opengl32.dll" ALIAS "glCallLists" (BYVAL n AS GLsizei, BYVAL ntype AS GLenum, BYVAL lists AS ANY)
DECLARE SUB glClear LIB "opengl32.dll" ALIAS "glClear" (BYVAL mask AS GLbitfield)
DECLARE SUB glClearAccum LIB "opengl32.dll" ALIAS "glClearAccum" (BYVAL red AS GLfloat, BYVAL green AS GLfloat, BYVAL blue AS GLfloat, BYVAL alpha AS GLfloat)
DECLARE SUB glClearColor LIB "opengl32.dll" ALIAS "glClearColor" (BYVAL red AS GLclampf, BYVAL green AS GLclampf, BYVAL blue AS GLclampf, BYVAL alpha AS GLclampf)
DECLARE SUB glClearDepth LIB "opengl32.dll" ALIAS "glClearDepth" (BYVAL depth AS GLclampd)
DECLARE SUB glClearIndex LIB "opengl32.dll" ALIAS "glClearIndex" (BYVAL c AS GLfloat)
DECLARE SUB glClearStencil LIB "opengl32.dll" ALIAS "glClearStencil" (BYVAL s AS GLint)
DECLARE SUB glClipPlane LIB "opengl32.dll" ALIAS "glClipPlane" (BYVAL plane AS GLenum, BYREF equation AS GLdouble)
DECLARE SUB glColor3b LIB "opengl32.dll" ALIAS "glColor3b" (BYVAL red AS GLbyte, BYVAL green AS GLbyte, BYVAL blue AS GLbyte)
DECLARE SUB glColor3bv LIB "opengl32.dll" ALIAS "glColor3bv" (BYREF v AS GLbyte)
DECLARE SUB glColor3d LIB "opengl32.dll" ALIAS "glColor3d" (BYVAL red AS GLdouble, BYVAL green AS GLdouble, BYVAL blue AS GLdouble)
DECLARE SUB glColor3dv LIB "opengl32.dll" ALIAS "glColor3dv" (BYREF v AS GLdouble)
DECLARE SUB glColor3f LIB "opengl32.dll" ALIAS "glColor3f" (BYVAL red AS GLfloat, BYVAL green AS GLfloat, BYVAL blue AS GLfloat)
DECLARE SUB glColor3fv LIB "opengl32.dll" ALIAS "glColor3fv" (BYREF v AS GLfloat)
DECLARE SUB glColor3i LIB "opengl32.dll" ALIAS "glColor3i" (BYVAL red AS GLint, BYVAL green AS GLint, BYVAL blue AS GLint)
DECLARE SUB glColor3iv LIB "opengl32.dll" ALIAS "glColor3iv" (BYREF v AS GLint)
DECLARE SUB glColor3s LIB "opengl32.dll" ALIAS "glColor3s" (BYVAL red AS GLshort, BYVAL green AS GLshort, BYVAL blue AS GLshort)
DECLARE SUB glColor3sv LIB "opengl32.dll" ALIAS "glColor3sv" (BYREF v AS GLshort)
DECLARE SUB glColor3ub LIB "opengl32.dll" ALIAS "glColor3ub" (BYVAL red AS GLubyte, BYVAL green AS GLubyte, BYVAL blue AS GLubyte)
DECLARE SUB glColor3ubv LIB "opengl32.dll" ALIAS "glColor3ubv" (BYREF v AS GLubyte)
DECLARE SUB glColor3ui LIB "opengl32.dll" ALIAS "glColor3ui" (BYVAL red AS GLuint, BYVAL green AS GLuint, BYVAL blue AS GLuint)
DECLARE SUB glColor3uiv LIB "opengl32.dll" ALIAS "glColor3uiv" (BYREF v AS GLuint)
DECLARE SUB glColor3us LIB "opengl32.dll" ALIAS "glColor3us" (BYVAL red AS GLushort, BYVAL green AS GLushort, BYVAL blue AS GLushort)
DECLARE SUB glColor3usv LIB "opengl32.dll" ALIAS "glColor3usv" (BYREF v AS GLushort)
DECLARE SUB glColor4b LIB "opengl32.dll" ALIAS "glColor4b" (BYVAL red AS GLbyte, BYVAL green AS GLbyte, BYVAL blue AS GLbyte, BYVAL alpha AS GLbyte)
DECLARE SUB glColor4bv LIB "opengl32.dll" ALIAS "glColor4bv" (BYREF v AS GLbyte)
DECLARE SUB glColor4d LIB "opengl32.dll" ALIAS "glColor4d" (BYVAL red AS GLdouble, BYVAL green AS GLdouble, BYVAL blue AS GLdouble, BYVAL alpha AS GLdouble)
DECLARE SUB glColor4dv LIB "opengl32.dll" ALIAS "glColor4dv" (BYREF v AS GLdouble)
DECLARE SUB glColor4f LIB "opengl32.dll" ALIAS "glColor4f" (BYVAL red AS GLfloat, BYVAL green AS GLfloat, BYVAL blue AS GLfloat, BYVAL alpha AS GLfloat)
DECLARE SUB glColor4fv LIB "opengl32.dll" ALIAS "glColor4fv" (BYREF v AS GLfloat)
DECLARE SUB glColor4i LIB "opengl32.dll" ALIAS "glColor4i" (BYVAL red AS GLint, BYVAL green AS GLint, BYVAL blue AS GLint, BYVAL alpha AS GLint)
DECLARE SUB glColor4iv LIB "opengl32.dll" ALIAS "glColor4iv" (BYREF v AS GLint)
DECLARE SUB glColor4s LIB "opengl32.dll" ALIAS "glColor4s" (BYVAL red AS GLshort, BYVAL green AS GLshort, BYVAL blue AS GLshort, BYVAL alpha AS GLshort)
DECLARE SUB glColor4sv LIB "opengl32.dll" ALIAS "glColor4sv" (BYREF v AS GLshort)
DECLARE SUB glColor4ub LIB "opengl32.dll" ALIAS "glColor4ub" (BYVAL red AS GLubyte, BYVAL green AS GLubyte, BYVAL blue AS GLubyte, BYVAL alpha AS GLubyte)
DECLARE SUB glColor4ubv LIB "opengl32.dll" ALIAS "glColor4ubv" (BYREF v AS GLubyte)
DECLARE SUB glColor4ui LIB "opengl32.dll" ALIAS "glColor4ui" (BYVAL red AS GLuint, BYVAL green AS GLuint, BYVAL blue AS GLuint, BYVAL alpha AS GLuint)
DECLARE SUB glColor4uiv LIB "opengl32.dll" ALIAS "glColor4uiv" (BYREF v AS GLuint)
DECLARE SUB glColor4us LIB "opengl32.dll" ALIAS "glColor4us" (BYVAL red AS GLushort, BYVAL green AS GLushort, BYVAL blue AS GLushort, BYVAL alpha AS GLushort)
DECLARE SUB glColor4usv LIB "opengl32.dll" ALIAS "glColor4usv" (BYREF v AS GLushort)
DECLARE SUB glColorMask LIB "opengl32.dll" ALIAS "glColorMask" (BYVAL red AS GLboolean, BYVAL green AS GLboolean, BYVAL blue AS GLboolean, BYVAL alpha AS GLboolean)
DECLARE SUB glColorMaterial LIB "opengl32.dll" ALIAS "glColorMaterial" (BYVAL face AS GLenum, BYVAL mode AS GLenum)
DECLARE SUB glColorPointer LIB "opengl32.dll" ALIAS "glColorPointer" (BYVAL SIZE AS GLint, BYVAL ntype AS GLenum, BYVAL stride AS GLsizei, BYREF POINT AS GLvoid)
DECLARE SUB glCopyPixels LIB "opengl32.dll" ALIAS "glCopyPixels" (BYVAL x AS GLint, BYVAL y AS GLint, BYVAL nwidth AS GLsizei, BYVAL height AS GLsizei, BYVAL ntype AS GLenum)
DECLARE SUB glCopyTexImage1D LIB "opengl32.dll" ALIAS "glCopyTexImage1D" (BYVAL ntarget AS GLenum, BYVAL level AS GLint, BYVAL internalformat AS GLenum, BYVAL x AS GLint, BYVAL y AS GLint, BYVAL nwidth AS GLsizei, BYVAL border AS GLint)
DECLARE SUB glCopyTexImage2D LIB "opengl32.dll" ALIAS "glCopyTexImage2D" (BYVAL ntarget AS GLenum, BYVAL level AS GLint, BYVAL internalformat AS GLenum, BYVAL x AS GLint, BYVAL y AS GLint, BYVAL nwidth AS GLsizei, BYVAL height AS GLsizei, BYVAL border AS _
GLint)
DECLARE SUB glCopyTexSubImage1D LIB "opengl32.dll" ALIAS "glCopyTexSubImage1D" (BYVAL ntarget AS GLenum, BYVAL level AS GLint, BYVAL xoffset AS GLint, BYVAL x AS GLint, BYVAL y AS GLint, BYVAL nwidth AS GLsizei)
DECLARE SUB glCopyTexSubImage2D LIB "opengl32.dll" ALIAS "glCopyTexSubImage2D" (BYVAL ntarget AS GLenum, BYVAL level AS GLint, BYVAL xoffset AS GLint, BYVAL yoffset AS GLint, BYVAL x AS GLint, BYVAL y AS GLint, BYVAL nwidth AS GLsizei, BYVAL height AS _
GLsizei)
DECLARE SUB glCullFace LIB "opengl32.dll" ALIAS "glCullFace" (BYVAL mode AS GLenum)
DECLARE SUB glDeleteLists LIB "opengl32.dll" ALIAS "glDeleteLists" (BYVAL list AS GLuint, BYVAL range AS GLsizei)
DECLARE SUB glDeleteTextures LIB "opengl32.dll" ALIAS "glDeleteTextures" (BYVAL n AS GLsizei, BYREF textures AS GLuint)
DECLARE SUB glDepthFunc LIB "opengl32.dll" ALIAS "glDepthFunc" (BYVAL func AS GLenum)
DECLARE SUB glDepthMask LIB "opengl32.dll" ALIAS "glDepthMask" (BYVAL flag AS GLboolean)
DECLARE SUB glDepthRange LIB "opengl32.dll" ALIAS "glDepthRange" (BYVAL zNear AS GLclampd, BYVAL zFar AS GLclampd)
DECLARE SUB glDisable LIB "opengl32.dll" ALIAS "glDisable" (BYVAL cap AS GLenum)
DECLARE SUB glDisableClientState LIB "opengl32.dll" ALIAS "glDisableClientState" (BYVAL narray AS GLenum)
DECLARE SUB glDrawArrays LIB "opengl32.dll" ALIAS "glDrawArrays" (BYVAL mode AS GLenum, BYVAL first AS GLint, BYVAL count AS GLsizei)
DECLARE SUB glDrawBuffer LIB "opengl32.dll" ALIAS "glDrawBuffer" (BYVAL mode AS GLenum)
DECLARE SUB glDrawElements LIB "opengl32.dll" ALIAS "glDrawElements" (BYVAL mode AS GLenum, BYVAL count AS GLsizei, BYVAL ntype AS GLenum, BYREF indices AS GLvoid)
DECLARE SUB glDrawPixels LIB "opengl32.dll" ALIAS "glDrawPixels" (BYVAL nwidth AS GLsizei, BYVAL height AS GLsizei, BYVAL format AS GLenum, BYVAL ntype AS GLenum, BYREF npixels AS GLvoid)
DECLARE SUB glEdgeFlag LIB "opengl32.dll" ALIAS "glEdgeFlag" (BYVAL flag AS GLboolean)
DECLARE SUB glEdgeFlagPointer LIB "opengl32.dll" ALIAS "glEdgeFlagPointer" (BYVAL stride AS GLsizei, BYREF POINT AS GLboolean)
DECLARE SUB glEdgeFlagv LIB "opengl32.dll" ALIAS "glEdgeFlagv" (BYREF flag AS GLboolean)
DECLARE SUB glEnable LIB "opengl32.dll" ALIAS "glEnable" (BYVAL cap AS GLenum)
DECLARE SUB glEnableClientState LIB "opengl32.dll" ALIAS "glEnableClientState" (BYVAL narray AS GLenum)
DECLARE SUB glEnd LIB "opengl32.dll" ALIAS "glEnd"
DECLARE SUB glEndList LIB "opengl32.dll" ALIAS "glEndList"
DECLARE SUB glEvalCoord1d LIB "opengl32.dll" ALIAS "glEvalCoord1d" (BYVAL u AS GLdouble)
DECLARE SUB glEvalCoord1dv LIB "opengl32.dll" ALIAS "glEvalCoord1dv" (BYREF u AS GLdouble)
DECLARE SUB glEvalCoord1f LIB "opengl32.dll" ALIAS "glEvalCoord1f" (BYVAL u AS GLfloat)
DECLARE SUB glEvalCoord1fv LIB "opengl32.dll" ALIAS "glEvalCoord1fv" (BYREF u AS GLfloat)
DECLARE SUB glEvalCoord2d LIB "opengl32.dll" ALIAS "glEvalCoord2d" (BYVAL u AS GLdouble, BYVAL v AS GLdouble)
DECLARE SUB glEvalCoord2dv LIB "opengl32.dll" ALIAS "glEvalCoord2dv" (BYREF u AS GLdouble)
DECLARE SUB glEvalCoord2f LIB "opengl32.dll" ALIAS "glEvalCoord2f" (BYVAL u AS GLfloat, BYVAL v AS GLfloat)
DECLARE SUB glEvalCoord2fv LIB "opengl32.dll" ALIAS "glEvalCoord2fv" (BYREF u AS GLfloat)
DECLARE SUB glEvalMesh1 LIB "opengl32.dll" ALIAS "glEvalMesh1" (BYVAL mode AS GLenum, BYVAL i1 AS GLint, BYVAL i2 AS GLint)
DECLARE SUB glEvalMesh2 LIB "opengl32.dll" ALIAS "glEvalMesh2" (BYVAL mode AS GLenum, BYVAL i1 AS GLint, BYVAL i2 AS GLint, BYVAL j1 AS GLint, BYVAL j2 AS GLint)
DECLARE SUB glEvalPoint1 LIB "opengl32.dll" ALIAS "glEvalPoint1" (BYVAL i AS GLint)
DECLARE SUB glEvalPoint2 LIB "opengl32.dll" ALIAS "glEvalPoint2" (BYVAL i AS GLint, BYVAL j AS GLint)
DECLARE SUB glFeedbackBuffer LIB "opengl32.dll" ALIAS "glFeedbackBuffer" (BYVAL SIZE AS GLsizei, BYVAL ntype AS GLenum, BYREF buffer AS GLfloat)
DECLARE SUB glFinish LIB "opengl32.dll" ALIAS "glFinish"
DECLARE SUB glFlush LIB "opengl32.dll" ALIAS "glFlush"
DECLARE SUB glFogf LIB "opengl32.dll" ALIAS "glFogf" (BYVAL pname AS GLenum, BYVAL param AS GLfloat)
DECLARE SUB glFogfv LIB "opengl32.dll" ALIAS "glFogfv" (BYVAL pname AS GLenum, BYREF params AS GLfloat)
DECLARE SUB glFogi LIB "opengl32.dll" ALIAS "glFogi" (BYVAL pname AS GLenum, BYVAL param AS GLint)
DECLARE SUB glFogiv LIB "opengl32.dll" ALIAS "glFogiv" (BYVAL pname AS GLenum, BYREF params AS GLint)
DECLARE SUB glFrontFace LIB "opengl32.dll" ALIAS "glFrontFace" (BYVAL mode AS GLenum)
DECLARE SUB glFrustum LIB "opengl32.dll" ALIAS "glFrustum" (BYVAL nleft AS GLdouble, BYVAL nright AS GLdouble, BYVAL bottom AS GLdouble, BYVAL top AS GLdouble, BYVAL zNear AS GLdouble, BYVAL zFar AS GLdouble)
DECLARE FUNCTION glGenLists LIB "opengl32.dll" ALIAS "glGenLists" (BYVAL range AS GLsizei) AS GLuint
DECLARE SUB glGenTextures LIB "opengl32.dll" ALIAS "glGenTextures" (BYVAL n AS GLsizei, BYREF textures AS GLuint)
DECLARE SUB glGetBooleanv LIB "opengl32.dll" ALIAS "glGetBooleanv" (BYVAL pname AS GLenum, BYREF params AS GLboolean)
DECLARE SUB glGetClipPlane LIB "opengl32.dll" ALIAS "glGetClipPlane" (BYVAL plane AS GLenum, BYREF equation AS GLdouble)
DECLARE SUB glGetDoublev LIB "opengl32.dll" ALIAS "glGetDoublev" (BYVAL pname AS GLenum, BYREF params AS GLdouble)
DECLARE FUNCTION glGetError LIB "opengl32.dll" ALIAS "glGetError" () AS GLenum
DECLARE SUB glGetFloatv LIB "opengl32.dll" ALIAS "glGetFloatv" (BYVAL pname AS GLenum, BYREF params AS GLfloat)
DECLARE SUB glGetIntegerv LIB "opengl32.dll" ALIAS "glGetIntegerv" (BYVAL pname AS GLenum, BYREF params AS GLint)
DECLARE SUB glGetLightfv LIB "opengl32.dll" ALIAS "glGetLightfv" (BYVAL light AS GLenum, BYVAL pname AS GLenum, BYREF params AS GLfloat)
DECLARE SUB glGetLightiv LIB "opengl32.dll" ALIAS "glGetLightiv" (BYVAL light AS GLenum, BYVAL pname AS GLenum, BYREF params AS GLint)
DECLARE SUB glGetMapdv LIB "opengl32.dll" ALIAS "glGetMapdv" (BYVAL ntarget AS GLenum, BYVAL query AS GLenum, BYREF v AS GLdouble)
DECLARE SUB glGetMapfv LIB "opengl32.dll" ALIAS "glGetMapfv" (BYVAL ntarget AS GLenum, BYVAL query AS GLenum, BYREF v AS GLfloat)
DECLARE SUB glGetMapiv LIB "opengl32.dll" ALIAS "glGetMapiv" (BYVAL ntarget AS GLenum, BYVAL query AS GLenum, BYREF v AS GLint)
DECLARE SUB glGetMaterialfv LIB "opengl32.dll" ALIAS "glGetMaterialfv" (BYVAL face AS GLenum, BYVAL pname AS GLenum, BYREF params AS GLfloat)
DECLARE SUB glGetMaterialiv LIB "opengl32.dll" ALIAS "glGetMaterialiv" (BYVAL face AS GLenum, BYVAL pname AS GLenum, BYREF params AS GLint)
DECLARE SUB glGetPixelMapfv LIB "opengl32.dll" ALIAS "glGetPixelMapfv" (BYVAL map AS GLenum, BYREF values AS GLfloat)
DECLARE SUB glGetPixelMapuiv LIB "opengl32.dll" ALIAS "glGetPixelMapuiv" (BYVAL map AS GLenum, BYREF values AS GLuint)
DECLARE SUB glGetPixelMapusv LIB "opengl32.dll" ALIAS "glGetPixelMapusv" (BYVAL map AS GLenum, BYREF values AS GLushort)
DECLARE SUB glGetPointerv LIB "opengl32.dll" ALIAS "glGetPointerv" (BYVAL pname AS GLenum, BYREF params AS GLuint)
DECLARE SUB glGetPolygonStipple LIB "opengl32.dll" ALIAS "glGetPolygonStipple" (BYREF mask AS GLubyte)
DECLARE SUB glGetTexEnvfv LIB "opengl32.dll" ALIAS "glGetTexEnvfv" (BYVAL ntarget AS GLenum, BYVAL pname AS GLenum, BYREF params AS GLfloat)
DECLARE SUB glGetTexEnviv LIB "opengl32.dll" ALIAS "glGetTexEnviv" (BYVAL ntarget AS GLenum, BYVAL pname AS GLenum, BYREF params AS GLint)
DECLARE SUB glGetTexGendv LIB "opengl32.dll" ALIAS "glGetTexGendv" (BYVAL ncoord AS GLenum, BYVAL pname AS GLenum, BYREF params AS GLdouble)
DECLARE SUB glGetTexGenfv LIB "opengl32.dll" ALIAS "glGetTexGenfv" (BYVAL ncoord AS GLenum, BYVAL pname AS GLenum, BYREF params AS GLfloat)
DECLARE SUB glGetTexGeniv LIB "opengl32.dll" ALIAS "glGetTexGeniv" (BYVAL ncoord AS GLenum, BYVAL pname AS GLenum, BYREF params AS GLint)
DECLARE SUB glGetTexImage LIB "opengl32.dll" ALIAS "glGetTexImage" (BYVAL ntarget AS GLenum, BYVAL level AS GLint, BYVAL format AS GLenum, BYVAL ntype AS GLenum, BYREF npixels AS GLvoid)
DECLARE SUB glGetTexLevelParameterfv LIB "opengl32.dll" ALIAS "glGetTexLevelParameterfv" (BYVAL ntarget AS GLenum, BYVAL level AS GLint, BYVAL pname AS GLenum, BYREF params AS GLfloat)
DECLARE SUB glGetTexLevelParameteriv LIB "opengl32.dll" ALIAS "glGetTexLevelParameteriv" (BYVAL ntarget AS GLenum, BYVAL level AS GLint, BYVAL pname AS GLenum, BYREF params AS GLint)
DECLARE SUB glGetTexParameterfv LIB "opengl32.dll" ALIAS "glGetTexParameterfv" (BYVAL ntarget AS GLenum, BYVAL pname AS GLenum, BYREF params AS GLfloat)
DECLARE SUB glGetTexParameteriv LIB "opengl32.dll" ALIAS "glGetTexParameteriv" (BYVAL ntarget AS GLenum, BYVAL pname AS GLenum, BYREF params AS GLint)
DECLARE SUB glHint LIB "opengl32.dll" ALIAS "glHint" (BYVAL ntarget AS GLenum, BYVAL mode AS GLenum)
DECLARE SUB glIndexMask LIB "opengl32.dll" ALIAS "glIndexMask" (BYVAL mask AS GLuint)
DECLARE SUB glIndexPointer LIB "opengl32.dll" ALIAS "glIndexPointer" (BYVAL ntype AS GLenum, BYVAL stride AS GLsizei, BYREF npointer AS GLvoid)
DECLARE SUB glIndexd LIB "opengl32.dll" ALIAS "glIndexd" (BYVAL c AS GLdouble)
DECLARE SUB glIndexdv LIB "opengl32.dll" ALIAS "glIndexdv" (BYREF c AS GLdouble)
DECLARE SUB glIndexf LIB "opengl32.dll" ALIAS "glIndexf" (BYVAL c AS GLfloat)
DECLARE SUB glIndexfv LIB "opengl32.dll" ALIAS "glIndexfv" (BYREF c AS GLfloat)
DECLARE SUB glIndexi LIB "opengl32.dll" ALIAS "glIndexi" (BYVAL c AS GLint)
DECLARE SUB glIndexiv LIB "opengl32.dll" ALIAS "glIndexiv" (BYREF c AS GLint)
DECLARE SUB glIndexs LIB "opengl32.dll" ALIAS "glIndexs" (BYVAL c AS GLshort)
DECLARE SUB glIndexsv LIB "opengl32.dll" ALIAS "glIndexsv" (BYREF c AS GLshort)
DECLARE SUB glIndexub LIB "opengl32.dll" ALIAS "glIndexub" (BYVAL c AS GLubyte)
DECLARE SUB glIndexubv LIB "opengl32.dll" ALIAS "glIndexubv" (BYREF c AS GLubyte)
DECLARE SUB glInitNames LIB "opengl32.dll" ALIAS "glInitNames"
DECLARE SUB glInterleavedArrays LIB "opengl32.dll" ALIAS "glInterleavedArrays" (BYVAL format AS GLenum, BYVAL stride AS GLsizei, BYREF POINT AS GLvoid)
DECLARE FUNCTION glIsEnabled LIB "opengl32.dll" ALIAS "glIsEnabled" (BYVAL cap AS GLenum) AS GLboolean
DECLARE FUNCTION glIsList LIB "opengl32.dll" ALIAS "glIsList" (BYVAL list AS GLuint) AS GLboolean
DECLARE FUNCTION glIsTexture LIB "opengl32.dll" ALIAS "glIsTexture" (BYVAL texture AS GLuint) AS GLboolean
DECLARE SUB glLightModelf LIB "opengl32.dll" ALIAS "glLightModelf" (BYVAL pname AS GLenum, BYVAL param AS GLfloat)
DECLARE SUB glLightModelfv LIB "opengl32.dll" ALIAS "glLightModelfv" (BYVAL pname AS GLenum, BYREF params AS GLfloat)
DECLARE SUB glLightModeli LIB "opengl32.dll" ALIAS "glLightModeli" (BYVAL pname AS GLenum, BYVAL param AS GLint)
DECLARE SUB glLightModeliv LIB "opengl32.dll" ALIAS "glLightModeliv" (BYVAL pname AS GLenum, BYREF params AS GLint)
DECLARE SUB glLightf LIB "opengl32.dll" ALIAS "glLightf" (BYVAL light AS GLenum, BYVAL pname AS GLenum, BYVAL param AS GLfloat)
DECLARE SUB glLightfv LIB "opengl32.dll" ALIAS "glLightfv" (BYVAL light AS GLenum, BYVAL pname AS GLenum, BYREF params AS GLfloat)
DECLARE SUB glLighti LIB "opengl32.dll" ALIAS "glLighti" (BYVAL light AS GLenum, BYVAL pname AS GLenum, BYVAL param AS GLint)
DECLARE SUB glLightiv LIB "opengl32.dll" ALIAS "glLightiv" (BYVAL light AS GLenum, BYVAL pname AS GLenum, BYREF params AS GLint)
DECLARE SUB glLineStipple LIB "opengl32.dll" ALIAS "glLineStipple" (BYVAL factor AS GLint, BYVAL pattern AS GLushort)
DECLARE SUB glLineWidth LIB "opengl32.dll" ALIAS "glLineWidth" (BYVAL nWIDTH AS GLfloat)
DECLARE SUB glListBase LIB "opengl32.dll" ALIAS "glListBase" (BYVAL nBASE AS GLuint)
DECLARE SUB glLoadIdentity LIB "opengl32.dll" ALIAS "glLoadIdentity"
DECLARE SUB glLoadMatrixd LIB "opengl32.dll" ALIAS "glLoadMatrixd" (BYREF m AS GLdouble)
DECLARE SUB glLoadMatrixf LIB "opengl32.dll" ALIAS "glLoadMatrixf" (BYREF m AS GLfloat)
DECLARE SUB glLoadName LIB "opengl32.dll" ALIAS "glLoadName" (BYVAL nNAME AS GLuint)
DECLARE SUB glLogicOp LIB "opengl32.dll" ALIAS "glLogicOp" (BYVAL opcode AS GLenum)
DECLARE SUB glMap1d LIB "opengl32.dll" ALIAS "glMap1d" (BYVAL ntarget AS GLenum, BYVAL u1 AS GLdouble, BYVAL u2 AS GLdouble, BYVAL stride AS GLint, BYVAL order AS GLint, BYREF npoints AS GLdouble)
DECLARE SUB glMap1f LIB "opengl32.dll" ALIAS "glMap1f" (BYVAL ntarget AS GLenum, BYVAL u1 AS GLfloat, BYVAL u2 AS GLfloat, BYVAL stride AS GLint, BYVAL order AS GLint, BYREF npoints AS GLfloat)
DECLARE SUB glMap2d LIB "opengl32.dll" ALIAS "glMap2d" (BYVAL ntarg AS GLenum, BYVAL u1 AS GLdouble, BYVAL u2 AS GLdouble, BYVAL ustride AS GLint, BYVAL uorder AS GLint, BYVAL v1 AS GLdouble, BYVAL v2 AS GLdouble, BYVAL vstride AS GLint, BYVAL vorder AS _
GLint, BYREF npoints AS GLdouble)
DECLARE SUB glMap2f LIB "opengl32.dll" ALIAS "glMap2f" (BYVAL ntarget AS GLenum, BYVAL u1 AS GLfloat, BYVAL u2 AS GLfloat, BYVAL ustride AS GLint, BYVAL uorder AS GLint, BYVAL v1 AS GLfloat, BYVAL v2 AS GLfloat, BYVAL vstride AS GLint, BYVAL vorder AS _
GLint, BYREF npoints AS GLfloat)
DECLARE SUB glMapGrid1d LIB "opengl32.dll" ALIAS "glMapGrid1d" (BYVAL un AS GLint, BYVAL u1 AS GLdouble, BYVAL u2 AS GLdouble)
DECLARE SUB glMapGrid1f LIB "opengl32.dll" ALIAS "glMapGrid1f" (BYVAL un AS GLint, BYVAL u1 AS GLfloat, BYVAL u2 AS GLfloat)
DECLARE SUB glMapGrid2d LIB "opengl32.dll" ALIAS "glMapGrid2d" (BYVAL un AS GLint, BYVAL u1 AS GLdouble, BYVAL u2 AS GLdouble, BYVAL vn AS GLint, BYVAL v1 AS GLdouble, BYVAL v2 AS GLdouble)
DECLARE SUB glMapGrid2f LIB "opengl32.dll" ALIAS "glMapGrid2f" (BYVAL un AS GLint, BYVAL u1 AS GLfloat, BYVAL u2 AS GLfloat, BYVAL vn AS GLint, BYVAL v1 AS GLfloat, BYVAL v2 AS GLfloat)
DECLARE SUB glMaterialf LIB "opengl32.dll" ALIAS "glMaterialf" (BYVAL face AS GLenum, BYVAL pname AS GLenum, BYVAL param AS GLfloat)
DECLARE SUB glMaterialfv LIB "opengl32.dll" ALIAS "glMaterialfv" (BYVAL face AS GLenum, BYVAL pname AS GLenum, BYREF params AS GLfloat)
DECLARE SUB glMateriali LIB "opengl32.dll" ALIAS "glMateriali" (BYVAL face AS GLenum, BYVAL pname AS GLenum, BYVAL param AS GLint)
DECLARE SUB glMaterialiv LIB "opengl32.dll" ALIAS "glMaterialiv" (BYVAL face AS GLenum, BYVAL pname AS GLenum, BYREF params AS GLint)
DECLARE SUB glMatrixMode LIB "opengl32.dll" ALIAS "glMatrixMode" (BYVAL mode AS GLenum)
DECLARE SUB glMultMatrixd LIB "opengl32.dll" ALIAS "glMultMatrixd" (BYREF m AS GLdouble)
DECLARE SUB glMultMatrixf LIB "opengl32.dll" ALIAS "glMultMatrixf" (BYREF m AS GLfloat)
DECLARE SUB glNewList LIB "opengl32.dll" ALIAS "glNewList" (BYVAL list AS GLuint, BYVAL mode AS GLenum)
DECLARE SUB glNormal3b LIB "opengl32.dll" ALIAS "glNormal3b" (BYVAL nx AS GLbyte, BYVAL ny AS GLbyte, BYVAL nz AS GLbyte)
DECLARE SUB glNormal3bv LIB "opengl32.dll" ALIAS "glNormal3bv" (BYREF v AS GLbyte)
DECLARE SUB glNormal3d LIB "opengl32.dll" ALIAS "glNormal3d" (BYVAL nx AS GLdouble, BYVAL ny AS GLdouble, BYVAL nz AS GLdouble)
DECLARE SUB glNormal3dv LIB "opengl32.dll" ALIAS "glNormal3dv" (BYREF v AS GLdouble)
DECLARE SUB glNormal3f LIB "opengl32.dll" ALIAS "glNormal3f" (BYVAL nx AS GLfloat, BYVAL ny AS GLfloat, BYVAL nz AS GLfloat)
DECLARE SUB glNormal3fv LIB "opengl32.dll" ALIAS "glNormal3fv" (BYREF v AS GLfloat)
DECLARE SUB glNormal3i LIB "opengl32.dll" ALIAS "glNormal3i" (BYVAL nx AS GLint, BYVAL ny AS GLint, BYVAL nz AS GLint)
DECLARE SUB glNormal3iv LIB "opengl32.dll" ALIAS "glNormal3iv" (BYREF v AS GLint)
DECLARE SUB glNormal3s LIB "opengl32.dll" ALIAS "glNormal3s" (BYVAL nx AS GLshort, BYVAL ny AS GLshort, BYVAL nz AS GLshort)
DECLARE SUB glNormal3sv LIB "opengl32.dll" ALIAS "glNormal3sv" (BYREF v AS GLshort)
DECLARE SUB glNormalPointer LIB "opengl32.dll" ALIAS "glNormalPointer" (BYVAL nTYPE AS GLenum, BYVAL stride AS GLsizei, BYREF POINT AS GLvoid)
DECLARE SUB glOrtho LIB "opengl32.dll" ALIAS "glOrtho" (BYVAL nLEFT AS GLdouble, BYVAL nRIGHT AS GLdouble, BYVAL bottom AS GLdouble, BYVAL top AS GLdouble, BYVAL zNear AS GLdouble, BYVAL zFar AS GLdouble)
DECLARE SUB glPassThrough LIB "opengl32.dll" ALIAS "glPassThrough" (BYVAL token AS GLfloat)
DECLARE SUB glPixelMapfv LIB "opengl32.dll" ALIAS "glPixelMapfv" (BYVAL map AS GLenum, BYVAL mapsize AS GLint, BYREF values AS GLfloat)
DECLARE SUB glPixelMapuiv LIB "opengl32.dll" ALIAS "glPixelMapuiv" (BYVAL map AS GLenum, BYVAL mapsize AS GLint, BYREF values AS GLuint)
DECLARE SUB glPixelMapusv LIB "opengl32.dll" ALIAS "glPixelMapusv" (BYVAL map AS GLenum, BYVAL mapsize AS GLint, BYREF values AS GLushort)
DECLARE SUB glPixelStoref LIB "opengl32.dll" ALIAS "glPixelStoref" (BYVAL pname AS GLenum, BYVAL param AS GLfloat)
DECLARE SUB glPixelStorei LIB "opengl32.dll" ALIAS "glPixelStorei" (BYVAL pname AS GLenum, BYVAL param AS GLint)
DECLARE SUB glPixelTransferf LIB "opengl32.dll" ALIAS "glPixelTransferf" (BYVAL pname AS GLenum, BYVAL param AS GLfloat)
DECLARE SUB glPixelTransferi LIB "opengl32.dll" ALIAS "glPixelTransferi" (BYVAL pname AS GLenum, BYVAL param AS GLint)
DECLARE SUB glPixelZoom LIB "opengl32.dll" ALIAS "glPixelZoom" (BYVAL xfactor AS GLfloat, BYVAL yfactor AS GLfloat)
DECLARE SUB glPointSize LIB "opengl32.dll" ALIAS "glPointSize" (BYVAL SIZE AS GLfloat)
DECLARE SUB glPolygonMode LIB "opengl32.dll" ALIAS "glPolygonMode" (BYVAL face AS GLenum, BYVAL mode AS GLenum)
DECLARE SUB glPolygonOffset LIB "opengl32.dll" ALIAS "glPolygonOffset" (BYVAL factor AS GLfloat, BYVAL nUNITS AS GLfloat)
DECLARE SUB glPolygonStipple LIB "opengl32.dll" ALIAS "glPolygonStipple" (BYREF mask AS GLubyte)
DECLARE SUB glPopAttrib LIB "opengl32.dll" ALIAS "glPopAttrib"
DECLARE SUB glPopClientAttrib LIB "opengl32.dll" ALIAS "glPopClientAttrib"
DECLARE SUB glPopMatrix LIB "opengl32.dll" ALIAS "glPopMatrix"
DECLARE SUB glPopName LIB "opengl32.dll" ALIAS "glPopName"
DECLARE SUB glPrioritizeTextures LIB "opengl32.dll" ALIAS "glPrioritizeTextures" (BYVAL n AS GLsizei, BYREF textures AS GLuint, BYREF priorities AS GLclampf)
DECLARE SUB glPushAttrib LIB "opengl32.dll" ALIAS "glPushAttrib" (BYVAL mask AS GLbitfield)
DECLARE SUB glPushClientAttrib LIB "opengl32.dll" ALIAS "glPushClientAttrib" (BYVAL mask AS GLbitfield)
DECLARE SUB glPushMatrix LIB "opengl32.dll" ALIAS "glPushMatrix"
DECLARE SUB glPushName LIB "opengl32.dll" ALIAS "glPushName" (BYVAL nNAME AS GLuint)
DECLARE SUB glRasterPos2d LIB "opengl32.dll" ALIAS "glRasterPos2d" (BYVAL x AS GLdouble, BYVAL y AS GLdouble)
DECLARE SUB glRasterPos2dv LIB "opengl32.dll" ALIAS "glRasterPos2dv" (BYREF v AS GLdouble)
DECLARE SUB glRasterPos2f LIB "opengl32.dll" ALIAS "glRasterPos2f" (BYVAL x AS GLfloat, BYVAL y AS GLfloat)
DECLARE SUB glRasterPos2fv LIB "opengl32.dll" ALIAS "glRasterPos2fv" (BYREF v AS GLfloat)
DECLARE SUB glRasterPos2i LIB "opengl32.dll" ALIAS "glRasterPos2i" (BYVAL x AS GLint, BYVAL y AS GLint)
DECLARE SUB glRasterPos2iv LIB "opengl32.dll" ALIAS "glRasterPos2iv" (BYREF v AS GLint)
DECLARE SUB glRasterPos2s LIB "opengl32.dll" ALIAS "glRasterPos2s" (BYVAL x AS GLshort, BYVAL y AS GLshort)
DECLARE SUB glRasterPos2sv LIB "opengl32.dll" ALIAS "glRasterPos2sv" (BYREF v AS GLshort)
DECLARE SUB glRasterPos3d LIB "opengl32.dll" ALIAS "glRasterPos3d" (BYVAL x AS GLdouble, BYVAL y AS GLdouble, BYVAL z AS GLdouble)
DECLARE SUB glRasterPos3dv LIB "opengl32.dll" ALIAS "glRasterPos3dv" (BYREF v AS GLdouble)
DECLARE SUB glRasterPos3f LIB "opengl32.dll" ALIAS "glRasterPos3f" (BYVAL x AS GLfloat, BYVAL y AS GLfloat, BYVAL z AS GLfloat)
DECLARE SUB glRasterPos3fv LIB "opengl32.dll" ALIAS "glRasterPos3fv" (BYREF v AS GLfloat)
DECLARE SUB glRasterPos3i LIB "opengl32.dll" ALIAS "glRasterPos3i" (BYVAL x AS GLint, BYVAL y AS GLint, BYVAL z AS GLint)
DECLARE SUB glRasterPos3iv LIB "opengl32.dll" ALIAS "glRasterPos3iv" (BYREF v AS GLint)
DECLARE SUB glRasterPos3s LIB "opengl32.dll" ALIAS "glRasterPos3s" (BYVAL x AS GLshort, BYVAL y AS GLshort, BYVAL z AS GLshort)
DECLARE SUB glRasterPos3sv LIB "opengl32.dll" ALIAS "glRasterPos3sv" (BYREF v AS GLshort)
DECLARE SUB glRasterPos4d LIB "opengl32.dll" ALIAS "glRasterPos4d" (BYVAL x AS GLdouble, BYVAL y AS GLdouble, BYVAL z AS GLdouble, BYVAL w AS GLdouble)
DECLARE SUB glRasterPos4dv LIB "opengl32.dll" ALIAS "glRasterPos4dv" (BYREF v AS GLdouble)
DECLARE SUB glRasterPos4f LIB "opengl32.dll" ALIAS "glRasterPos4f" (BYVAL x AS GLfloat, BYVAL y AS GLfloat, BYVAL z AS GLfloat, BYVAL w AS GLfloat)
DECLARE SUB glRasterPos4fv LIB "opengl32.dll" ALIAS "glRasterPos4fv" (BYREF v AS GLfloat)
DECLARE SUB glRasterPos4i LIB "opengl32.dll" ALIAS "glRasterPos4i" (BYVAL x AS GLint, BYVAL y AS GLint, BYVAL z AS GLint, BYVAL w AS GLint)
DECLARE SUB glRasterPos4iv LIB "opengl32.dll" ALIAS "glRasterPos4iv" (BYREF v AS GLint)
DECLARE SUB glRasterPos4s LIB "opengl32.dll" ALIAS "glRasterPos4s" (BYVAL x AS GLshort, BYVAL y AS GLshort, BYVAL z AS GLshort, BYVAL w AS GLshort)
DECLARE SUB glRasterPos4sv LIB "opengl32.dll" ALIAS "glRasterPos4sv" (BYREF v AS GLshort)
DECLARE SUB glReadBuffer LIB "opengl32.dll" ALIAS "glReadBuffer" (BYVAL mode AS GLenum)
DECLARE SUB glReadPixels LIB "opengl32.dll" ALIAS "glReadPixels" (BYVAL x AS GLint, BYVAL y AS GLint, BYVAL nWIDTH AS GLsizei, BYVAL height AS GLsizei, BYVAL format AS GLenum, BYVAL nTYPE AS GLenum, BYREF nPIXELS AS GLvoid)
DECLARE SUB glRectd LIB "opengl32.dll" ALIAS "glRectd" (BYVAL x1 AS GLdouble, BYVAL y1 AS GLdouble, BYVAL x2 AS GLdouble, BYVAL y2 AS GLdouble)
DECLARE SUB glRectdv LIB "opengl32.dll" ALIAS "glRectdv" (BYREF v1 AS GLdouble, BYREF v2 AS GLdouble)
DECLARE SUB glRectf LIB "opengl32.dll" ALIAS "glRectf" (BYVAL x1 AS GLfloat, BYVAL y1 AS GLfloat, BYVAL x2 AS GLfloat, BYVAL y2 AS GLfloat)
DECLARE SUB glRectfv LIB "opengl32.dll" ALIAS "glRectfv" (BYREF v1 AS GLfloat, BYREF v2 AS GLfloat)
DECLARE SUB glRecti LIB "opengl32.dll" ALIAS "glRecti" (BYVAL x1 AS GLint, BYVAL y1 AS GLint, BYVAL x2 AS GLint, BYVAL y2 AS GLint)
DECLARE SUB glRectiv LIB "opengl32.dll" ALIAS "glRectiv" (BYREF v1 AS GLint, BYREF v2 AS GLint)
DECLARE SUB glRects LIB "opengl32.dll" ALIAS "glRects" (BYVAL x1 AS GLshort, BYVAL y1 AS GLshort, BYVAL x2 AS GLshort, BYVAL y2 AS GLshort)
DECLARE SUB glRectsv LIB "opengl32.dll" ALIAS "glRectsv" (BYREF v1 AS GLshort, BYREF v2 AS GLshort)
DECLARE FUNCTION glRenderMode LIB "opengl32.dll" ALIAS "glRenderMode" (BYVAL mode AS GLenum) AS GLint
DECLARE SUB glRotated LIB "opengl32.dll" ALIAS "glRotated" (BYVAL angle AS GLdouble, BYVAL x AS GLdouble, BYVAL y AS GLdouble, BYVAL z AS GLdouble)
DECLARE SUB glRotatef LIB "opengl32.dll" ALIAS "glRotatef" (BYVAL angle AS GLfloat, BYVAL x AS GLfloat, BYVAL y AS GLfloat, BYVAL z AS GLfloat)
DECLARE SUB glScaled LIB "opengl32.dll" ALIAS "glScaled" (BYVAL x AS GLdouble, BYVAL y AS GLdouble, BYVAL z AS GLdouble)
DECLARE SUB glScalef LIB "opengl32.dll" ALIAS "glScalef" (BYVAL x AS GLfloat, BYVAL y AS GLfloat, BYVAL z AS GLfloat)
DECLARE SUB glScissor LIB "opengl32.dll" ALIAS "glScissor" (BYVAL x AS GLint, BYVAL y AS GLint, BYVAL nWIDTH AS GLsizei, BYVAL height AS GLsizei)
DECLARE SUB glSelectBuffer LIB "opengl32.dll" ALIAS "glSelectBuffer" (BYVAL SIZE AS GLsizei, BYREF buffer AS GLuint)
DECLARE SUB glShadeModel LIB "opengl32.dll" ALIAS "glShadeModel" (BYVAL mode AS GLenum)
DECLARE SUB glStencilFunc LIB "opengl32.dll" ALIAS "glStencilFunc" (BYVAL func AS GLenum, BYVAL ref AS GLint, BYVAL mask AS GLuint)
DECLARE SUB glStencilMask LIB "opengl32.dll" ALIAS "glStencilMask" (BYVAL mask AS GLuint)
DECLARE SUB glStencilOp LIB "opengl32.dll" ALIAS "glStencilOp" (BYVAL fail AS GLenum, BYVAL zfail AS GLenum, BYVAL zpass AS GLenum)
DECLARE SUB glTexCoord1d LIB "opengl32.dll" ALIAS "glTexCoord1d" (BYVAL s AS GLdouble)
DECLARE SUB glTexCoord1dv LIB "opengl32.dll" ALIAS "glTexCoord1dv" (BYREF v AS GLdouble)
DECLARE SUB glTexCoord1f LIB "opengl32.dll" ALIAS "glTexCoord1f" (BYVAL s AS GLfloat)
DECLARE SUB glTexCoord1fv LIB "opengl32.dll" ALIAS "glTexCoord1fv" (BYREF v AS GLfloat)
DECLARE SUB glTexCoord1i LIB "opengl32.dll" ALIAS "glTexCoord1i" (BYVAL s AS GLint)
DECLARE SUB glTexCoord1iv LIB "opengl32.dll" ALIAS "glTexCoord1iv" (BYREF v AS GLint)
DECLARE SUB glTexCoord1s LIB "opengl32.dll" ALIAS "glTexCoord1s" (BYVAL s AS GLshort)
DECLARE SUB glTexCoord1sv LIB "opengl32.dll" ALIAS "glTexCoord1sv" (BYREF v AS GLshort)
DECLARE SUB glTexCoord2d LIB "opengl32.dll" ALIAS "glTexCoord2d" (BYVAL s AS GLdouble, BYVAL t AS GLdouble)
DECLARE SUB glTexCoord2dv LIB "opengl32.dll" ALIAS "glTexCoord2dv" (BYREF v AS GLdouble)
DECLARE SUB glTexCoord2f LIB "opengl32.dll" ALIAS "glTexCoord2f" (BYVAL s AS GLfloat, BYVAL t AS GLfloat)
DECLARE SUB glTexCoord2fv LIB "opengl32.dll" ALIAS "glTexCoord2fv" (BYREF v AS GLfloat)
DECLARE SUB glTexCoord2i LIB "opengl32.dll" ALIAS "glTexCoord2i" (BYVAL s AS GLint, BYVAL t AS GLint)
DECLARE SUB glTexCoord2iv LIB "opengl32.dll" ALIAS "glTexCoord2iv" (BYREF v AS GLint)
DECLARE SUB glTexCoord2s LIB "opengl32.dll" ALIAS "glTexCoord2s" (BYVAL s AS GLshort, BYVAL t AS GLshort)
DECLARE SUB glTexCoord2sv LIB "opengl32.dll" ALIAS "glTexCoord2sv" (BYREF v AS GLshort)
DECLARE SUB glTexCoord3d LIB "opengl32.dll" ALIAS "glTexCoord3d" (BYVAL s AS GLdouble, BYVAL t AS GLdouble, BYVAL r AS GLdouble)
DECLARE SUB glTexCoord3dv LIB "opengl32.dll" ALIAS "glTexCoord3dv" (BYREF v AS GLdouble)
DECLARE SUB glTexCoord3f LIB "opengl32.dll" ALIAS "glTexCoord3f" (BYVAL s AS GLfloat, BYVAL t AS GLfloat, BYVAL r AS GLfloat)
DECLARE SUB glTexCoord3fv LIB "opengl32.dll" ALIAS "glTexCoord3fv" (BYREF v AS GLfloat)
DECLARE SUB glTexCoord3i LIB "opengl32.dll" ALIAS "glTexCoord3i" (BYVAL s AS GLint, BYVAL t AS GLint, BYVAL r AS GLint)
DECLARE SUB glTexCoord3iv LIB "opengl32.dll" ALIAS "glTexCoord3iv" (BYREF v AS GLint)
DECLARE SUB glTexCoord3s LIB "opengl32.dll" ALIAS "glTexCoord3s" (BYVAL s AS GLshort, BYVAL t AS GLshort, BYVAL r AS GLshort)
DECLARE SUB glTexCoord3sv LIB "opengl32.dll" ALIAS "glTexCoord3sv" (BYREF v AS GLshort)
DECLARE SUB glTexCoord4d LIB "opengl32.dll" ALIAS "glTexCoord4d" (BYVAL s AS GLdouble, BYVAL t AS GLdouble, BYVAL r AS GLdouble, BYVAL q AS GLdouble)
DECLARE SUB glTexCoord4dv LIB "opengl32.dll" ALIAS "glTexCoord4dv" (BYREF v AS GLdouble)
DECLARE SUB glTexCoord4f LIB "opengl32.dll" ALIAS "glTexCoord4f" (BYVAL s AS GLfloat, BYVAL t AS GLfloat, BYVAL r AS GLfloat, BYVAL q AS GLfloat)
DECLARE SUB glTexCoord4fv LIB "opengl32.dll" ALIAS "glTexCoord4fv" (BYREF v AS GLfloat)
DECLARE SUB glTexCoord4i LIB "opengl32.dll" ALIAS "glTexCoord4i" (BYVAL s AS GLint, BYVAL t AS GLint, BYVAL r AS GLint, BYVAL q AS GLint)
DECLARE SUB glTexCoord4iv LIB "opengl32.dll" ALIAS "glTexCoord4iv" (BYREF v AS GLint)
DECLARE SUB glTexCoord4s LIB "opengl32.dll" ALIAS "glTexCoord4s" (BYVAL s AS GLshort, BYVAL t AS GLshort, BYVAL r AS GLshort, BYVAL q AS GLshort)
DECLARE SUB glTexCoord4sv LIB "opengl32.dll" ALIAS "glTexCoord4sv" (BYREF v AS GLshort)
DECLARE SUB glTexCoordPointer LIB "opengl32.dll" ALIAS "glTexCoordPointer" (BYVAL SIZE AS GLint, BYVAL nTYPE AS GLenum, BYVAL stride AS GLsizei, BYREF POINT AS GLvoid)
DECLARE SUB glTexEnvf LIB "opengl32.dll" ALIAS "glTexEnvf" (BYVAL ntarget AS GLenum, BYVAL pname AS GLenum, BYVAL param AS GLfloat)
DECLARE SUB glTexEnvfv LIB "opengl32.dll" ALIAS "glTexEnvfv" (BYVAL ntarget AS GLenum, BYVAL pname AS GLenum, BYREF params AS GLfloat)
DECLARE SUB glTexEnvi LIB "opengl32.dll" ALIAS "glTexEnvi" (BYVAL ntarget AS GLenum, BYVAL pname AS GLenum, BYVAL param AS GLint)
DECLARE SUB glTexEnviv LIB "opengl32.dll" ALIAS "glTexEnviv" (BYVAL ntarget AS GLenum, BYVAL pname AS GLenum, BYREF params AS GLint)
DECLARE SUB glTexGend LIB "opengl32.dll" ALIAS "glTexGend" (BYVAL ncoord AS GLenum, BYVAL pname AS GLenum, BYVAL param AS GLdouble)
DECLARE SUB glTexGendv LIB "opengl32.dll" ALIAS "glTexGendv" (BYVAL ncoord AS GLenum, BYVAL pname AS GLenum, BYREF params AS GLdouble)
DECLARE SUB glTexGenf LIB "opengl32.dll" ALIAS "glTexGenf" (BYVAL ncoord AS GLenum, BYVAL pname AS GLenum, BYVAL param AS GLfloat)
DECLARE SUB glTexGenfv LIB "opengl32.dll" ALIAS "glTexGenfv" (BYVAL ncoord AS GLenum, BYVAL pname AS GLenum, BYREF params AS GLfloat)
DECLARE SUB glTexGeni LIB "opengl32.dll" ALIAS "glTexGeni" (BYVAL ncoord AS GLenum, BYVAL pname AS GLenum, BYVAL param AS GLint)
DECLARE SUB glTexGeniv LIB "opengl32.dll" ALIAS "glTexGeniv" (BYVAL ncoord AS GLenum, BYVAL pname AS GLenum, BYREF params AS GLint)
DECLARE SUB glTexImage1D LIB "opengl32.dll" ALIAS "glTexImage1D" (BYVAL ntarget AS GLenum, BYVAL level AS GLint, BYVAL components AS GLint, BYVAL nWIDTH AS GLsizei, BYVAL border AS GLint, BYVAL format AS GLenum, BYVAL nTYP AS GLenum, BYREF nPIX AS GLvoid)
DECLARE SUB glTexImage2D LIB "opengl32.dll" ALIAS "glTexImage2D" (BYVAL ntarget AS GLenum, BYVAL level AS GLint, BYVAL components AS GLint, BYVAL nWIDTH AS GLsizei, BYVAL height AS GLsizei, BYVAL border AS GLint, BYVAL format AS GLenum, BYVAL nTYPE AS _
GLenum, BYREF nPIXELS AS GLvoid)
DECLARE SUB glTexParameterf LIB "opengl32.dll" ALIAS "glTexParameterf" (BYVAL ntarget AS GLenum, BYVAL pname AS GLenum, BYVAL param AS GLfloat)
DECLARE SUB glTexParameterfv LIB "opengl32.dll" ALIAS "glTexParameterfv" (BYVAL ntarget AS GLenum, BYVAL pname AS GLenum, BYREF params AS GLfloat)
DECLARE SUB glTexParameteri LIB "opengl32.dll" ALIAS "glTexParameteri" (BYVAL ntarget AS GLenum, BYVAL pname AS GLenum, BYVAL param AS GLint)
DECLARE SUB glTexParameteriv LIB "opengl32.dll" ALIAS "glTexParameteriv" (BYVAL ntarget AS GLenum, BYVAL pname AS GLenum, BYREF params AS GLint)
DECLARE SUB glTexSubImage1D LIB "opengl32.dll" ALIAS "glTexSubImage1D" (BYVAL ntarget AS GLenum, BYVAL level AS GLint, BYVAL xoffset AS GLint, BYVAL nWIDTH AS GLsizei, BYVAL format AS GLenum, BYVAL nTYPE AS GLenum, BYREF nPIXELS AS GLvoid)
DECLARE SUB glTexSubImage2D LIB "opengl32.dll" ALIAS "glTexSubImage2D" (BYVAL ntarg AS GLenum, BYVAL level AS GLint, BYVAL xoffset AS GLint, BYVAL yoffset AS GLint, BYVAL nWIDTH AS GLsizei, BYVAL height AS GLsizei, BYVAL format AS GLenum, BYVAL nTYPE AS _
GLenum, BYREF nPIXELS AS GLvoid)
DECLARE SUB glTranslated LIB "opengl32.dll" ALIAS "glTranslated" (BYVAL x AS GLdouble, BYVAL y AS GLdouble, BYVAL z AS GLdouble)
DECLARE SUB glTranslatef LIB "opengl32.dll" ALIAS "glTranslatef" (BYVAL x AS GLfloat, BYVAL y AS GLfloat, BYVAL z AS GLfloat)
DECLARE SUB glVertex2d LIB "opengl32.dll" ALIAS "glVertex2d" (BYVAL x AS GLdouble, BYVAL y AS GLdouble)
DECLARE SUB glVertex2dv LIB "opengl32.dll" ALIAS "glVertex2dv" (BYREF v AS GLdouble)
DECLARE SUB glVertex2f LIB "opengl32.dll" ALIAS "glVertex2f" (BYVAL x AS GLfloat, BYVAL y AS GLfloat)
DECLARE SUB glVertex2fv LIB "opengl32.dll" ALIAS "glVertex2fv" (BYREF v AS GLfloat)
DECLARE SUB glVertex2i LIB "opengl32.dll" ALIAS "glVertex2i" (BYVAL x AS GLint, BYVAL y AS GLint)
DECLARE SUB glVertex2iv LIB "opengl32.dll" ALIAS "glVertex2iv" (BYREF v AS GLint)
DECLARE SUB glVertex2s LIB "opengl32.dll" ALIAS "glVertex2s" (BYVAL x AS GLshort, BYVAL y AS GLshort)
DECLARE SUB glVertex2sv LIB "opengl32.dll" ALIAS "glVertex2sv" (BYREF v AS GLshort)
DECLARE SUB glVertex3d LIB "opengl32.dll" ALIAS "glVertex3d" (BYVAL x AS GLdouble, BYVAL y AS GLdouble, BYVAL z AS GLdouble)
DECLARE SUB glVertex3dv LIB "opengl32.dll" ALIAS "glVertex3dv" (BYREF v AS GLdouble)
DECLARE SUB glVertex3f LIB "opengl32.dll" ALIAS "glVertex3f" (BYVAL x AS GLfloat, BYVAL y AS GLfloat, BYVAL z AS GLfloat)
DECLARE SUB glVertex3fv LIB "opengl32.dll" ALIAS "glVertex3fv" (BYREF v AS GLfloat)
DECLARE SUB glVertex3i LIB "opengl32.dll" ALIAS "glVertex3i" (BYVAL x AS GLint, BYVAL y AS GLint, BYVAL z AS GLint)
DECLARE SUB glVertex3iv LIB "opengl32.dll" ALIAS "glVertex3iv" (BYREF v AS GLint)
DECLARE SUB glVertex3s LIB "opengl32.dll" ALIAS "glVertex3s" (BYVAL x AS GLshort, BYVAL y AS GLshort, BYVAL z AS GLshort)
DECLARE SUB glVertex3sv LIB "opengl32.dll" ALIAS "glVertex3sv" (BYREF v AS GLshort)
DECLARE SUB glVertex4d LIB "opengl32.dll" ALIAS "glVertex4d" (BYVAL x AS GLdouble, BYVAL y AS GLdouble, BYVAL z AS GLdouble, BYVAL w AS GLdouble)
DECLARE SUB glVertex4dv LIB "opengl32.dll" ALIAS "glVertex4dv" (BYREF v AS GLdouble)
DECLARE SUB glVertex4f LIB "opengl32.dll" ALIAS "glVertex4f" (BYVAL x AS GLfloat, BYVAL y AS GLfloat, BYVAL z AS GLfloat, BYVAL w AS GLfloat)
DECLARE SUB glVertex4fv LIB "opengl32.dll" ALIAS "glVertex4fv" (BYREF v AS GLfloat)
DECLARE SUB glVertex4i LIB "opengl32.dll" ALIAS "glVertex4i" (BYVAL x AS GLint, BYVAL y AS GLint, BYVAL z AS GLint, BYVAL w AS GLint)
DECLARE SUB glVertex4iv LIB "opengl32.dll" ALIAS "glVertex4iv" (BYREF v AS GLint)
DECLARE SUB glVertex4s LIB "opengl32.dll" ALIAS "glVertex4s" (BYVAL x AS GLshort, BYVAL y AS GLshort, BYVAL z AS GLshort, BYVAL w AS GLshort)
DECLARE SUB glVertex4sv LIB "opengl32.dll" ALIAS "glVertex4sv" (BYREF v AS GLshort)
DECLARE SUB glVertexPointer LIB "opengl32.dll" ALIAS "glVertexPointer" (BYVAL SIZE AS GLint, BYVAL nTYPE AS GLenum, BYVAL stride AS GLsizei, BYREF POINT AS GLvoid)
DECLARE SUB glViewport LIB "opengl32.dll" ALIAS "glViewport" (BYVAL x AS GLint, BYVAL y AS GLint, BYVAL nWIDTH AS GLsizei, BYVAL height AS GLsizei)
DECLARE FUNCTION glGetString LIB "opengl32.dll" ALIAS "glGetString" (BYVAL nname AS GLuint) AS GLuint

#ENDIF
